{   FILEUNIT.PAS - FreePascal's unit with was written only for compatility
      with older programs. It may funct also under DOS)

    Copyright (C) 2002  <Petr Pisar>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details (file "copying").

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
      - paper mail     : Petr Pisar
                         Uhercice 53
                         Hermanuv Mestec
                         538 03
                         Czech Republic
      - electronic mail: petr.pisar@seznam.cz
      - web sites      : www.gjr.cz/~pisarp/
}
unit fileunit;
interface
type
  {pointer pro prenos dat ze/do souboru}
  type_buffer = array [0..65528] of byte;
var
  buffer : ^type_buffer;   {pointer pro prenos dat ze/do souboru}
  buffersmall :array [0..3]of byte; {mini buffer pro -||- }
  fileresult :word;

  procedure initfile;
  procedure shutfile;
  procedure openexistfile (soubor :string; var handler :word);
  procedure opennewfile (soubor :string; var handler :word);
  
  procedure openfileforreading (soubor :string; var f :file);
  procedure openfileforwriting (soubor :string; var f :file);

  procedure closefile (var f :file);

  procedure writefile (var f :file; data_ptr :pointer; count :word;
                    var execcount :word);
  procedure readfile (var f :file; data_ptr: pointer; count :word;
                    var execcount :word);

  procedure gotofile (var handler :file; abs_seg, abs_ofs :word);
{
  procedure sizefile (handler :word; var vel_seg, vel_ofs :word);
  procedure lseekbegin (handler :word; rel_seg, rel_ofs :word;
                      var abs_seg, abs_ofs :word);
  procedure lseeknow (handler :word; rel_seg, rel_ofs :word;
                      var abs_seg, abs_ofs :word);
  procedure lseekend (handler :word; rel_seg, rel_ofs :word;
                      var abs_seg, abs_ofs :word);

  procedure gotoeof (handler :word);
}

implementation
type
  p_datablok = array [0..65528] of byte;
var
  wordik :word;      {docasne bloky pameti pro zapis do var}
  datablok :^p_datablok;
  data_abs_ofs, data_abs_seg :word;
  data_vel_ofs, data_vel_seg :word;

  flag :boolean; {vlajka pro stav jednotky true = byla instalovana}

  a :word;

procedure initfile;
begin
  if not flag then begin
    {getmem (datablok, 100);}
    flag := true;
  end;
end;

procedure shutfile;
begin
  if flag then begin
    {freemem (datablok, 100);}
    flag := false;
  end;
end;

function pathdos2lin (cesta :string) :string;
var
  a :byte;
  ret :string;
begin
  ret := cesta;
  for a := 1 to length (ret) do 
    if ret [a] = '\'  then ret [a] := '/';
  pathdos2lin := ret;
end;

{Otevre jiz existujici soubor, jinak chyba}
procedure openexistfile (soubor :string; var handler :word);
begin
end;

{zalozi novy soubor - nesmi predtim existoivat, jinak chyba}
procedure opennewfile (soubor :string; var handler :word);
begin
end;

{otevre, pripadne zalozi novy soubor. Jeho obsah vymaze a pointer nastavi
  na zacatke souboru}
procedure openfileforreading (soubor :string; var f :file);
var
  a :word; 
begin
  assign (f, pathdos2lin(soubor));
  {$I-}
  reset (f, 1);
  {$I+}
  fileresult := ioresult; 
end;

procedure openfileforwriting (soubor :string; var f :file);
var
  a :word; 
begin
  assign (f, pathdos2lin(soubor));
  {$I-}
  rewrite (f, 1);
  {$I+}
  fileresult := ioresult;
end;

{Zavre soubor}
procedure closefile (var f :file);
begin
  close (f);
end;

{Pise do souboru}
procedure writefile (var f :file; data_ptr :pointer; count :word;
                    var execcount :word);
var
  data :^byte;
begin
  data := data_ptr;
  {$I-}
  blockwrite (f, data^, count, execcount);
  {$I+}
  fileresult := ioresult;
end;

{cte ze souboru do array of byte}
procedure readfile (var f :file; data_ptr :pointer; count :word;
                    var execcount :word);
var
  data :^byte;
begin
  data := data_ptr;
  {$I-}
  blockread (f, data^, count, execcount);
  {$I+}
  fileresult := ioresult;
end;

{presune pointer na pozadovane absolutni misto v souboru}
procedure gotofile (var handler :file; abs_seg, abs_ofs :word);
begin
  seek (handler, abs_ofs);
end;



(*
{presunuje cteci/zapisovaci ukazatel na zacatek souboru}
procedure lseekbegin (handler :word; rel_seg, rel_ofs :word;
                      var abs_seg, abs_ofs :word);



begin



  asm

  mov cx, rel_seg

  mov dx, rel_ofs



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 0H  {pointer na zacatek + cx:dx}





  int 021H



  {testuji zda nedoslo k chybe}

  jnc @nechyba

  {DOS to nevzal}

  @chyba:

    mov byte ptr ioresult, al {pisi chybovy kod do ioresult}

  jmp @konec

  {vse je OK}

  @nechyba:

    mov byte ptr ioresult, 0 {nuluji ioresult, protoze je vse OK}



    mov data_abs_seg, dx  {nova absolutni poloha pointeru dx:ax}

    mov data_abs_ofs, ax



  @konec:

  end;

  abs_seg := data_abs_seg;

  abs_ofs := data_abs_ofs;

end;



{zjistuje poloju cteciho/zapisovaciho ukazatele na aktual. poz. v souboru}

procedure lseeknow (handler :word; rel_seg, rel_ofs :word;

                      var abs_seg, abs_ofs :word);



begin

  asm

  mov cx, rel_seg

  mov dx, rel_ofs



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 01H  {pointer na aktualni pozici + cx:dx}



  int 021H



  {testuji zda nedoslo k chybe}

  jnc @nechyba

  {DOS to nevzal}

  @chyba:

    mov byte ptr ioresult, al {pisi chybovy kod do ioresult}

  jmp @konec

  {vse je OK}

  @nechyba:

    mov byte ptr ioresult, 0 {nuluji ioresult, protoze je vse OK}



    mov data_abs_seg, dx  {nova absolutni poloha pointeru dx:ax}

    mov data_abs_ofs, ax

  @konec:

  end;

  abs_seg := data_abs_seg;

  abs_ofs := data_abs_ofs;

end;



{presunuje cteci/zapisovaci ukazatel na konec souboru}

procedure lseekend (handler :word; rel_seg, rel_ofs :word;

                      var abs_seg, abs_ofs :word);



begin

  asm

  mov cx, rel_seg

  mov dx, rel_ofs



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 02H  {pointer na zacatek + cx:dx}



  int 021H



  {testuji zda nedoslo k chybe}

  jnc @nechyba

  {DOS to nevzal}

  @chyba:

    mov byte ptr ioresult, al {pisi chybovy kod do ioresult}

  jmp @konec

  {vse je OK}

  @nechyba:

    mov byte ptr ioresult, 0 {nuluji ioresult, protoze je vse OK}



    mov data_abs_seg, dx  {nova absolutni poloha pointeru dx:ax}

    mov data_abs_ofs, ax

  @konec:

  end;

  abs_seg := data_abs_seg;

  abs_ofs := data_abs_ofs;

end;



{zjistuje velikost souboru}

procedure sizefile (handler :word; var vel_seg, vel_ofs :word);

begin

  asm

  {zjistim si aktualni pozici pointeru}

  mov cx, 0H

  mov dx, 0H



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 01H  {pointer na akt. poz. + cx:dx}



  int 021H



  jc @chyba {testuji zda nedoslo k chybe}



  mov data_abs_seg, dx  {akt. poloha pointeru dx:ax}

  mov data_abs_ofs, ax





  {zjistim velikost tak, ze se presunu na konec}

  mov cx, 0H

  mov dx, 0H



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 02H  {pointer na konec + 0:0}



  int 021H



  jc @chyba {testuji zda nedoslo k chybe}



  mov data_vel_seg, dx  {ukladam velikost souboru}

  mov data_vel_ofs, ax



  {nastavuji pointer na puvodni pozici}

  mov cx, data_abs_seg

  mov dx, data_abs_ofs



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 00H  {pointer na zacatek + 0:0}



  int 021H



  jnc @nechyba {testuji zda nedoslo k chybe}

  {DOS to nevzal}

  @chyba:

    mov byte ptr ioresult, al {pisi chybovy kod do ioresult}

  jmp @konec

  {vse je OK}

  @nechyba:

    mov byte ptr ioresult, 0 {nuluji ioresult, protoze je vse OK}



    mov data_abs_seg, dx  {nova absolutni poloha pointeru dx:ax}

    mov data_abs_ofs, ax

  @konec:

  end;

  vel_seg := data_vel_seg;

  vel_ofs := data_vel_ofs;

end;

{presune pointer na konec souboru. Stjene jako

 lseekend (handler, 0, 0, abs_seg, abs_ofs), akorat ze nevyzaduje vystup}

procedure gotoeof (handler :word);

begin

  asm

  xor cx, cx  {nuluji relativni posun za konec souboru. Chci prece jen konec}

  xor dx, dx



  mov bx, handler {nacitam cislo souboru}

  mov ah, 042H

  mov al, 02H  {pointer na zacatek + cx:dx}



  int 021H



  {testuji zda nedoslo k chybe}

  jnc @nechyba

  {DOS to nevzal}

  @chyba:

    mov byte ptr ioresult, al {pisi chybovy kod do ioresult}

  jmp @konec

  {vse je OK}

  @nechyba:

    mov byte ptr ioresult, 0 {nuluji ioresult, protoze je vse OK}

  @konec:

  end;

end;
*)


end.
