{   KEYL.PAS - a free pascal unit under Linux which contents functions
      and procedurs that work with keyboard (It uses standart FreePascal's
      CRT unit)

    Copyright (C) 2002  <Petr Pisar>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details (file "copying").

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
      - paper mail     : Petr Pisar
                         Uhercice 53
                         Hermanuv Mestec
                         538 03
                         Czech Republic
      - electronic mail: petr.pisar@seznam.cz
      - web sites      : www.gjr.cz/~pisarp/
}

unit keyl;

interface

uses crt;
var
  {keyb:array[0..255] of byte;}
  wait_on_key :boolean;
  auto_proc_on_getkey :procedure;
  pocetinter :byte;
  shift, alt, ctrl, capslock, numlock, scrolllock, led_diody, key_type :byte;

procedure initkeyl;
procedure shutkeyl;
{procedure setkeymap (name_of_key_map :string);}
function getkey :char;
procedure clearkeybuffer;

implementation
const
  keyb_out :array [0..255] of char =
        (#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
      {1}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
      {2}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
      {3}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
      {4}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
      {5}#0, #0, #0, #0, #0, #0, #0, #0, #0, #171,
      {6}#172, #173, #174, #175, #176, #177, #178, #179, #180, #0,
      {7}#0, #184, #189, #185, #0, #190, #0, #192, #0, #187,
      {8}#191, #188, #183, #186, #0, #0, #0, #0, #0, #0,
      {9}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {10}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {11}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {12}#0, #0, #0, #0, #0, #0, #0, #0,
                                         #0, #0,
     {13}#0, #0, #0, #181, #182, #0, #0, #0, #0, #0,
     {14}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {15}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {16}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {17}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {18}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {19}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {20}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {21}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {22}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {23}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {24}#0, #0, #0, #0, #0, #0, #0, #0, #0, #0,
     {25}#0, #0, #0, #0, #0, #0);


procedure initkeyl;
begin
  wait_on_key := true;
  auto_proc_on_getkey := nil;
end;

procedure shutkeyl;
begin
end;

function getkey :char;
const
  max_zdrzeni = 1000;
var
  klav, pom :char;
  ord_klav :byte;
  priradil :boolean;
  zdrzeni :word;
begin
  {priradil := false;}
  getkey := #0;
  key_type := 0;

  {kdyz zadna klavesa nebyla stistena}
  if (not keypressed) then begin
    {je-li cekani na klavesu vypnuto -> koncime funkci}
    if not wait_on_key then exit
    {jinak cekame, dokud se neco nestiskne}
    else begin
      zdrzeni := 0;
      while not keypressed do begin
        {dynamicke zdrzovani - ze zacatku ceka malo, procesor je hodne zatizeny.
	 cim dele nebyla stistena klavesa, tim dele se ceka, zatizeni procesoru
	 klesa. Delka zdrzeni se zastavi na horni hranici urcene konstantou
	 'maz_zdrzeni'}
        delay (zdrzeni);
        if zdrzeni < max_zdrzeni then inc (zdrzeni);
        if auto_proc_on_getkey <> nil then auto_proc_on_getkey;
      end;
   end;
  end;

  if auto_proc_on_getkey <> nil then auto_proc_on_getkey;

  {rozbor stistene klavesy}
  begin
    klav := readkey;
    ord_klav := ord (klav);
    {neni predrazeni #0}
    if ord_klav <> 0 then begin
      {Esc, tab, enter, backspace}
      if ord_klav < 32 then key_type := 3;
      {cislice}
      if (ord_klav >= 48) and (ord_klav <= 57) then key_type := 1;
      {vse ostatni}
      if key_type = 0 then key_type := 2;
      {priradil := true;}
      getkey := klav;
    end;
    {predrazeni #0}
    if (ord_klav = 0) and (keypressed) then begin
      klav := readkey;
      ord_klav := ord (klav);

      {getkey := klav;}
      pom := keyb_out [ord_klav];
      getkey := pom;
      {funkcni klavesy}
      if ord (pom) <= 182 then key_type := 4
      {editacni, kurzorove klavesy}
      else key_type := 3;
    end;
  end;
end;

procedure clearkeybuffer;
begin
  while keypressed do readkey;
end;

end.
