{1.07b-iso-2}
{   KNIHOVNA - knihovna.pas: simple database utility for administration
      of register of books
      Ported under Linux from DOS version.


    Copyright (C) 2001-2003  <Petr Pisar>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details (file "copying").

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Author's address:
      - paper mail     : Petr Pisar
                         Uhercice 53
                         Hermanuv Mestec
                         538 03
                         Czech Republic
      - electronic mail: petr.pisar@seznam.cz
      - web sites      : http://www.fi.muni.cz/~xpisar/

}

(*logicky strom

  KNIHOVNA
    |
    v- INICIALIZCE
    |
    |
    v- SMYCKA
    |   -|
    |   |>- DOTAZKONEC
    |   ||
    |   ||
    |   |>- OZNACIT
    |   ||
    |   ||
    |   |>- INVERZEOZNACENI
    |   ||
    |   ||
    |   |>- OZNACITFILTER
    |   ||    |
    |   ^|    >- FORMULARFIND
    |   ||    |
    |   ||    |
    |   ^|    >- TESTUJMASKU
    |   ||
    |   ||
    |   |>- ODZNACITFILTER
    |   ||    |
    |   ^|    >- FORMULARFIND
    |   ||    |
    |   ||    |
    |   ^|    >- TESTUJMASKU
    |   ||
    |   ||
    |   |>- PRIDATKNIHU
    |   ||    |
    |   ^|    >- FORMULAR
    |   ||
    |   ||
    |   |>- EDITOVATKNIHU
    |   ||    |
    |   ||    >- FORMULAR
    |   ^|
    |   ||
    |   |>- SMAZATKNIHU
    |   ||
    |   ||
    |   ->- MENU
    |         |
    |         >- MENUKNIHA
    |         |    |
    |         |    >- PRIDATKNIHU
    |         |    |
    |         |    |
    |         |    >- SMAZATKNIHU
    |         |    |
    |         |    |
    |         |    >- EDITOVATKNIHU
    |         |
    |         |
    |         |
    |         >- DOTAZKONEC
    |
    |
    v- SHUTDOWN
    |




*)

{$M 16384, 0, 655360}  {definice velikosti Stacku a HeapSize}

uses tui, keyl, fileunit, linux;
const
  verze = '1.07b';  {cislo verze progr., kt. se propaguje do vsech vypisu}
  datum_kompilace = '5.11.2002'; {datum kompilace programu}
    {abeceda v ISO-8859-2 dle ceskeho pravopisu (nezna 'CH') vcetne nemeckych
     grafemu}
  abeceda :array [0..255] of byte=
{0} (0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
{10} 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
{20} 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
{30} 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
{40} 0, 0, 0, 0, 0, 0, 0, 0, 1, 2,
{50} 3, 4, 5, 6, 7, 8, 9, 10, 0, 0,
{60} 0, 0, 0, 0, 0, 11, 12, 13,{} 15, {} 17,          {A 65->11}
{70} 18, 19, 20, 21, 22, 23, 24, 25, 26, {} 28,
{80} 29, 30, 31,{} 33, {} 35, {} 37, 38, 39, 40, 41,
{90} 42, {} 0, 0, 0, 0, 0, 0, 11, 12, 13,              {a 97->11}
{100}{} 15, {} 17, 18, 19, 20, 21, 22, 23, 24, 25,
{110}26,{} 28, 29, 30, 31,{} 33, {} 35, {} 37, 38, 39,
{120}40, 41, 42, {} 0, 0, 0, 0, 0,


                                    0, 0,
{130}0, 0, 0, 0, 0, 0, 0, 0, 0, 0,              
{140}0, 0, 0, 0, 0, 0, 0, 0, 0, 0,             
{150}0, 0, 0, 0, 0, 0, 0, 0, 0, 0,                
{160}0, 0, 0, 24, 0, 24, 33, 0, 0, 34,              
{170}33, 36, 42, 0, 43, 42, 0, 11, 0, 24,         
{180}0, 24, 33, 0, 0, 34, 33, 36, 42, 0,           
{190}43, 42, 31, 11, 11, 11, 11, 24, 13, 13,    
{200}14, 17, 17, 17, 17, 21, 21, 16, 15, 26,     
{210}27, 28, 28, 28, 28, 0, 32, 37, 37, 37,          
{220}37, 41, 35, 33, 31, 11, 11, 11, 11, 24,   
{230}13, 13, 14, 17, 17, 17, 17, 21, 21, 16,    
{240}15, 26, 27, 28, 28, 28, 28, 0, 32, 37,      
{250}37, 37, 37, 41, 35, 0);



  {!!!!! udava kolik knih se vejde do databaze, jak velka pamet se prideli
   dynamickym promennym}
  maximalni_pocet_knih :word = 800;
  cesta_data_exp :string = '/home/petr/projekty/knihovna/usr/1.06/';
  cesta      :string = '/home/petr/projekty/knihovna/';
  {cesta      :string = '/';}
  cesta_data :string = 'usr/share/knihovna/';
  cesta_doc  :string = 'usr/doc/knihovna/';

type
  t_autor = array [0..799] of string [31];  {!!!NUTNE MODOFIKOVAT}
  t_nazev = array [0..799] of string [31];  {!!!NUTNE MODOFIKOVAT}
  t_rok = array [0..799] of string [4];
  t_cislo = array [0..799] of string [4];
  t_druh = array [0..799] of char;

  t_abc_total = array [0..799] of word;
  t_oznacen = array [0..799] of byte;

  t_radek_vypis = record                                                        
    text :string;                                                               
    fg, bg :byte;                                                               
  end;
var
  pocet_knih :word;     {cislo, ktere udava celkovy pocet knih - logicky}

  autor :^t_autor;      {zde jsou samotna data}
  nazev :^t_nazev;
  rok :^t_rok;
  cislo :^t_cislo;
  druh :^t_druh;

  abc_total :^t_abc_total;  {abecedni poradi v seznamu}
  oznacen :^t_oznacen;      {jestli je oznacen nebo ne}

  pocet_oznacen :word; {pocet oznacenych knih}

  modifikovano :boolean; {znaci jesli jsme neco modifikovaly, a tedy musime
                          pri ukoceni ulozit data na disk}

  horni :word; {ktera kniha bude zobrazena uplne nahore na obrazovce}
  dolni :word; {tahle bude zobrazena uplne dole}

  aktualni,         {na ktere knize je prave kurzor}
  virtualni :word;  {na kterem radku obrazovny je kurzor}

  find_autor, find_nazev :string [31]; {pamatuje posledni dotazovane udaje}
  find_rok, find_cislo :string [4];    {na oznaceni ci odznaceni}
  find_druh :char;

  filtr_autor, filtr_nazev :string [31]; {pamatuje posledni dotazovane udaje}
  filtr_rok, filtr_cislo :string [4];    {na filtr}
  filtr_druh :char;


  handl_autor, handl_nazev,  {Rukojeti k souborum, pod kt. se otviraji}
  handl_druh, handl_rok, handl_cislo,
  handl_kniha, handl_knihovna :file {word};
  {cesta :string;} {obsahuje cestu k adresari 'knihovna'}

  parent_proces :byte;   {znaci kdo danou proceduru spustil}

  {okna}
  hodiny :byte;
  hlavni_klavesova_napoveda :pointer; {Udava obsah posledniho
                                            radku na obrazovce v seznamu knih}
  vypis :array [0..21] of t_radek_vypis;

  konec_programu :boolean; {vlajka, znacici, zda cely program ma zkoncit}
  klavesa :char;
  
  upozorneni :byte; {okno s upozornenim na prazdou knihovnu}
  
  radek :word;
  a, b, c :word;
  aw, bw :word;
(*
{****************************************
 ****************************************
 nacita data ze souboru, konvertuje do textove podoby - formatuje konce radku
 a pote zobrazuje.
 !!! Neresi problem je-li radek delsi nez 78 znaku
 Omezeni: maximalne 1425 stranek}
procedure viewfile (soubor :string);
var
  data_binary :array [0..2049] of char; {(80 znaku + CR+LF) * 25 radku = 2050}
  data_text :array [0..22] of string [78];  {23 radku dlouhych 78 znaku
                                             - kolem dokola ramecek}
  stop_byte_na_stranku :array [0..1424] of word; {max. 1425 stranek}

  handl :file {word};

  delka, stop_byte :word;
  radek, virt_posun :word;
  stranka :word;

  klavesa :char;
  aw :word;

begin
  {otviram soubor}
  openfileforreading (soubor, handl);
    {nemohu otevrit soubor}
    if fileresult <> 0 then begin
      {dina (0, 1); pis (soubor); pisz ('%'); pisb (fileresult);}

      write (#7);
      exit;
    end;

  {Inicializace}
  stranka := 0;
  stop_byte_na_stranku [0] := 0;
  klavesa := #188;

  repeat

    stop_byte := stop_byte_na_stranku [stranka];

    {nactu data ze souboru}
    gotofile (handl, 0, stop_byte);
    readfile (handl, @data_binary, 2050, delka);

    {nuluji}
    radek := 0;
    for aw := 0 to 20 do data_text [aw] := '';

    {prevedu do textove podoby}
    for aw := 0 to delka do begin
      if (ord (data_binary [aw]) = 13) and (ord (data_binary [aw + 1]) = 10)
        then begin
        aw := aw + 1;
        radek := radek + 1;
        if radek = 10 then break;
      end
      else data_text [radek] := data_text [radek] + data_binary [aw];
    end;

    {ukladam stop_byte, jen kdyz to byl PgDn}
    if (klavesa = #188) then begin
      stop_byte_na_stranku [stranka + 1] := stop_byte + aw + 1;
    end;



    {zobrazim stranku}
    barva (7, 1);
    for aw := 0 to 9 do begin
      jdina (0, aw + 7);
      pis ('                                                                              ');
      jdina (1, aw + 7);
      pis (data_text [aw]);
    end;


    {klavesnice}
    repeat
      klavesa := getkey;
    until (klavesa = #27) or (klavesa = #188) or (klavesa = #185);


    {PgDn & jeste je co cist - nejsme na EOF & technicke omezeni poctu
     stranek}
    if (klavesa = #188) and (radek = 10) and (stranka < 1425) then begin
      stranka := stranka + 1;
    end;

    {PgUp}
    if (klavesa = #185) and (stranka <> 0) then begin
      stranka := stranka - 1;
    end;
    *)

    (*
    {vypis}
    jdina (0, 13);
    pis ('aw: ');
    pisw (aw);
    pis ('    ');
    jdina (0, 14);
    pis ('virt_posun: ');
    pisw (virt_posun);
    pis ('    ');
    jdina (0, 15);
    pis ('stop_byte: ');
    pisw (stop_byte);
    pis ('    ');
    jdina (0, 16);
    pis ('radek: ');
    pisw (radek);
    pis ('    ');
    jdina (0, 17);
    pis ('stranka: ');
    pisw (stranka);
    pis ('    ');
    jdina (0, 18);
    pis ('stop_byte_na_stranku: ');
    pisw (stop_byte_na_stranku [stranka]);
    pis ('    ');
    *)
(*
  until klavesa = #27;


  {zaviram soubor}
  closefile (handl);
end;
*)

(*
{****************************************
 ****************************************}
procedure licence;
begin
  {oramovani}
  barva (7, 1);
  jdina (0, 6);
  pis (' Licence ');
  jdina (0, 17);
  pis ('');
  {klaves. napoveda}
  jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('PgUp' + ',' + 'PgDn');
  barva (7, 1);
  pis ('Pohyb v textu                                                 ');

  viewfile (cesta + 'doc\copying');
end;
*)

{****************************************
 ****************************************}
procedure o_programu;
var
  o :byte;
  klavesa :char;
begin
  {otevru okno}
  swsize (nid, 58, 10);
  swcolor (7, 1);
  swtitle (nid, 'O Programu');
  swcenter (nid);
  openwindow (o);
  
  wpis ('                         KNIHOVNA                         ');
  wjdina (0, 1);
  wpis ('                Copyright (C) 2001 Petr Psa             ');
  wjdina (0, 2);
  wpis ('   ---------------------------------------------------    ');
  wjdina (0, 3);
  wpis ('      Verze:                Datum kompilace:              ');
  wjdina (13, 3);
  wpis (verze);
  wjdina (45, 3);
  wpis (datum_kompilace);
  wjdina (0, 4);
  wpis ('      Licence: GNU Generic Public Licence 2               ');
  wjdina (0, 5);
  wpis ('      Autor: Petr Psa                                   ');
  wjdina (0, 6);
  wpis (' Kontakt: Petr Psa, herice 53, 538 03 Hemanv Mstec ');
  wjdina (0, 7);
  wpis ('          esk republika                                 ');
  wjdina (0, 8);
  wpis ('          Pisarp@gjr.cz                                   ');
  wjdina (0, 9);
  wpis ('          Http://www.gjr.cz/~pisarp/download              ');
  {klaves. napoveda}
  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit                                                                      ');}
  repeat
    klavesa := getkey;
  until (klavesa = #27);

  closewindow (o);
end;

{******************************************}
function cas :string;
var
  h, m, s, ms :word;
  function i2s (i :integer): string;
  var s :string;
  begin
    str (i, s);
    i2s := s;
  end;
begin
  gettime (h, m, s, ms);
  {cas := i2s (h) + ':' + i2s (m) + ':' + i2s (s);}
  if h < 10 then cas := '0' else cas := '';
  cas := cas + i2s (h) + ':';
  if m < 10 then cas := cas + '0';
  cas := cas + i2s (m) + ':';
  if s < 10 then cas := cas + '0';
  cas := cas + i2s (s);
end;

{procedure zobrazcas;
begin
  changewindow (root);
  wbarva (7,1);
  wjdina (72, 0);
  wpis (cas);
end;}

procedure zobrazcas;
var 
  x_orig, y_orig:byte;
  x_kurzor_orig, y_kurzor_orig :byte;
  popredi_orig, pozadi_orig :byte;
  puvodni_okno :byte;
begin
  (*{nacte puvodni nastaveni obrazovky}
  getkurzorto (x_kurzor_orig, y_kurzor_orig);
  getjdina (x_orig, y_orig);
  getbarva (popredi_orig, pozadi_orig);*)
  {zobrazi akt. cas}
  {barva (7,1);}
  puvodni_okno := aid;
  changewindow (hodiny);
  wjdina (0, 0);
  wpis (cas);
  changewindow (puvodni_okno);
  wrefreshkurzor;
  {obnovi puvodni atributy obrazovky} 
  (*barva (popredi_orig, pozadi_orig);
  jdina (x_orig, y_orig);
  kurzorto (x_kurzor_orig, y_kurzor_orig);*)
end;


(*
{****************************************
 ****************************************
 Zobrazi okno a v nem obsah souboru '#cesta# + '\doc\' + #kapitola# + '.hlp''
 Jako parametr procedury 'kapitola' se predava jen cisty nazev souboru
 bez cesty a extenze}
procedure napoveda (kapitola :string);
var
  buffer :pointer; {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;
begin
  {ulozime pozadi}
  ctiblok (0, 6, 79, 17, buffer);
  ctiblok (0, 24, 79, 24, one_radek);

  {oramovani}
  barva (7, 1);
  jdina (0, 6);
  pis (' Npovda ');
  jdina (0, 17);
  pis ('');
  {klaves. napoveda}
  jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('PgUp' + ',' + 'PgDn');
  barva (7, 1);
  pis ('Pohyb v textu                                                 ');

  {zobrazim soubor}
  viewfile (cesta + 'doc\' + kapitola + '.hlp');

  {obnovim pozadi}
  pisblok (0, 6, buffer, true);
  pisblok (0, 24, one_radek, true);
end;
*)
{****************************************
 ****************************************}
procedure dotazkonec;
var
  a :byte;
  buffer :pointer; {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;
  klavesa :char;
  o :byte;
begin
  swcolor (7, 1);
  swsize (nid, 18, 2);
  swcenter (nid);
  swtitle (nid, '');
  openwindow (o);

  wjdina (0, 0);
  wpis (' Ukonit program? ');
  
  addbutton (2, 1, 'Ano');
  addbutton (11, 1, 'Ne');

  {
  jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('Enter');
  barva (7, 1);
  pis ('Potvrdit ');
  barva (1, 3);
  pis ('Tab,'+ #27 + ',' + #26);
  barva (7, 1);
  pis ('Pohyb v menu                                    ');
 } 
  a := runaktip (1);

  if (exit_key = #13) and (a = 0) then konec_programu := true {cheme zkoncit}
  else konec_programu := false; {nechceme zkoncit}
  
  klavesa := #0; {nutne, jinak nam program vyhodi editaci}

  wbarva (7, 1);
  wjdina (0, 24);

  closewindow (o);
  changewindow (root);
end;


{****************************************
 ****************************************
 Kurzor se posune o 1 knihu nahoru ... jako kdyz stisknete sipku nahoru.
 Procedura sama testuje zda je kurzor na 0. knize -> neni potreba davat tuto
 podminku pred volani teto procedury}
procedure jdioknihunahoru;
begin
  if (aktualni <> 0 ) and (pocet_knih <> 0) then begin
    aktualni := aktualni - 1;
    if (virtualni = 1) and (horni <> 0) then horni := horni - 1 {kurzor na
                                             2. radku -> posuneme obrazovku}
    else virtualni := virtualni - 1;
  end;
end;


{****************************************
 ****************************************
 Kurzor se posune o 1 knihu dolu ... jako kdyz stisknete sipku dolu.
 Testuje zda neni na konci}
procedure jdioknihudolu;
begin
  if (aktualni < (pocet_knih - 1)) and (pocet_knih <> 0)
    then begin {sipka dolu}
    aktualni := aktualni + 1;
    if virtualni = 20 then horni := horni + 1 {kdyz kurzor je na 21. radku}
    else virtualni := virtualni + 1;
  end;
end;


{****************************************
 ****************************************
 Kurzor se posune na predchozi oznacenou knihu.}
procedure jdinaoznacenouknihunahoru;
var
  a, b :word;
begin
  if ((aktualni > 0) and (pocet_knih <> 0) and (pocet_oznacen <> 0))
  then begin
    a := aktualni - 1;
    while ((a > 0) and (oznacen^[abc_total^[a]] <> 1)) do dec (a);
    {kdyz jsme nasli dalsi oznacenou}
    if oznacen^[abc_total^[a]] = 1 then 
      for b := aktualni-1 downto a do jdioknihunahoru;
  end;
end;

{****************************************
 ****************************************
 Kurzor se posune na dalsi oznacenou knihu.}
procedure jdinaoznacenouknihudolu;
var
  a, b :word;
begin
  if (aktualni < (pocet_knih-1)) and (pocet_knih <> 0) and (pocet_oznacen <> 0)
  then begin
    a := aktualni + 1;
    while ((a < pocet_knih) and (oznacen^[abc_total^[a]] <> 1)) do inc (a);
    {kdyz jsme nasli dalsi oznacenou}
    if oznacen^[abc_total^[a]] = 1 then 
      for b := aktualni to a-1 do jdioknihudolu;
  end;
end;


{************************************************************************
 ****************************************
 Zobrazuje indikaci}
procedure indikujdisk (radek, procenta :byte);
var
  a :byte;
begin
  wjdina (22, radek + 1);                {zobrazime %}
  wpisw (procenta);
  wpisz ('%');
  wjdina (1, radek);
  for a := 1 to (procenta shr 1) do begin {zobrazime pasek}
    wpisz ('#');
  end;
end;



{************************************************************************
 ****************************************
 Nacte data z disku}
procedure ctiknihovnu;
var
  data_dir :string;
  o, ch :byte;
begin
  {sestavuji cestu k adresari s daty}
  data_dir := cesta + cesta_data;
  if cesta_data_exp <> '' then data_dir := cesta_data_exp;


  {Nacitani dat z disku}
  pocet_knih := 0;
  abc_total^ [0] := 0;

  {barva (4, 15);
  jdina (0, 1);
  pis ('&' + cesta + '&');}

  {nacitam 'pocet_knih'}
  openfileforreading (data_dir + 'knihovna.dat', handl_knihovna);
    if fileresult <> 0 then begin
      swcolor (4, 15);
      swsize (nid, 60, 5);
      swtitle (nid, 'Chyba');
      swcenter (nid);
      openwindow (ch);
  
      wpis ('Chyba pri nacitani databaze!');
      wjdina (0, 1);
      wpis (data_dir);
      wjdina (0, 2);
      wpis ('#'); wpisw (fileresult);
      getkey;
      
      closewindow (ch);

      shuttui;
      shutfile;
      halt (1);
    end;
  if fileresult = 0 then begin
    readfile (handl_knihovna, @pocet_knih, 2, aw);
    closefile (handl_knihovna);
  end;
  {getkey;}

  {zobrazim indikacni pas}
  swcolor (7, 1);
  swsize (nid, 52, 3);
  swposition (nid, center, 16);
  {swtitle (nid, 'Natn');}
  swtitle (nid, data_dir);
  openwindow (o);
  wjdina (0, 0);
  wpis ('           Natm obsah knihovny z disku           ');
  wjdina (0, 1);
  wpis ('[__________________________________________________]');
  wjdina (0, 2);
  wpis ('                        0%                          ');


  {nacitam data}
  openfileforreading (data_dir + 'autor.dat', handl_autor);
  if fileresult = 0 then begin
    readfile (handl_autor, @autor^, pocet_knih * 32, aw);
    closefile (handl_autor);
  end;
    indikujdisk (1, 41);

  openfileforreading (data_dir + 'nazev.dat', handl_nazev);
  if fileresult = 0 then begin
    readfile (handl_nazev, @nazev^, pocet_knih * 32, aw);
    closefile (handl_nazev);
  end;
    indikujdisk (1, 82);

  openfileforreading (data_dir + 'rok.dat', handl_rok);
  if fileresult = 0 then begin
    readfile (handl_rok, @rok^, pocet_knih * 5, aw);
    closefile (handl_rok);
  end;
    indikujdisk (1, 88);

  openfileforreading (data_dir + 'druh.dat', handl_druh);
  if fileresult = 0 then begin
    readfile (handl_druh, @druh^, pocet_knih * 1, aw);
    closefile (handl_druh);
  end;
    indikujdisk (1, 90);

  openfileforreading (data_dir + 'cislo.dat', handl_cislo);
  if fileresult = 0 then begin
    readfile (handl_cislo, @cislo^, pocet_knih * 5, aw);
    closefile (handl_cislo);
  end;
    indikujdisk (1, 96);

  openfileforreading (data_dir + 'kniha.abc', handl_kniha);
  if fileresult = 0 then begin
    readfile (handl_kniha, @abc_total^, pocet_knih * 2, aw);
    closefile (handl_kniha);
  end;
    indikujdisk (1, 100);

  getkey;
  closewindow (o);
end;


{************************************************************************
 ****************************************
 Ulozi data na disk}
procedure ulozknihovnu;
begin
(*
  {uladam 'pocet_knih'}
  openfileforwriting (cesta + cesta_data + 'knihovna.dat', handl_knihovna);
    writefile (handl_knihovna, @pocet_knih, 2, aw);
  closefile (handl_knihovna);

  {zobrazim indikacni pas}
  barva (7, 1);
  jdina (13, 10);
  pis (' Ukldn ');
  jdina (13, 11);
  pis ('           Ukldm obsah knihovny na disk           ');
  jdina (13, 12);
  pis (' ************************************************** ');
  jdina (13, 13);
  pis ('                        0%                          ');
  jdina (13, 14);
  pis ('');


  {prepisuji data na disku}
  openfileforwriting (cesta + cesta_data + 'autor.dat', handl_autor);
  if fileresult = 0 then begin
    writefile (handl_autor, @autor^, pocet_knih * 32, aw);
    closefile (handl_autor);
  end;
    indikujdisk (12, 41);

  openfileforwriting (cesta + cesta_data + 'nazev.dat', handl_nazev);
  if fileresult = 0 then begin
    writefile (handl_nazev, @nazev^, pocet_knih * 32, aw);
    closefile (handl_nazev);
  end;
    indikujdisk (12, 82);

  openfileforwriting (cesta + cesta_data + 'rok.dat', handl_rok);
  if fileresult = 0 then begin
    writefile (handl_rok, @rok^, pocet_knih * 5, aw);
    closefile (handl_rok);
  end;
    indikujdisk (12, 88);

  openfileforwriting (cesta + cesta_data + 'druh.dat', handl_druh);
  if fileresult = 0 then begin
    writefile (handl_druh, @druh^, pocet_knih * 1, aw);
    closefile (handl_druh);
  end;
    indikujdisk (12, 90);

  openfileforwriting (cesta + cesta_data + 'cislo.dat', handl_cislo);
  if fileresult = 0 then begin
    writefile (handl_cislo, @cislo^, pocet_knih * 5, aw);
    closefile (handl_cislo);
  end;
    indikujdisk (12, 96);

  openfileforwriting (cesta + cesta_data + 'kniha.abc', handl_kniha);
  if fileresult = 0 then begin
    writefile (handl_kniha, @abc_total^, pocet_knih * 2, aw);
    closefile (handl_kniha);
  end;
    indikujdisk (12, 100);
*)
end;


(*
procedure print;
var
  handl :file{word};
  s :string;
  a, b, bw, aw, delka :word;
begin
  if pocet_knih = 0 then exit;
  openfileforwriting (cesta + 'tisk.txt', handl);
  if fileresult = 0 then begin
    for a := 0 to pocet_knih - 1 do begin
      bw := abc_total^ [a];
      s := '';
      s := autor^ [bw];
      for b := 0 to 31 - length(s) do s := s + ' ';
      s := s + nazev^ [bw] + #10 + #13;
      delka := length (s);
      s [0] := #32;
      writefile (handl, @s, delka, aw);
    end;
    closefile (handl);
  end;
end;
*)


{************************************************************************
 ****************************************
 Tato procedure vystavi formular pro editaci udaju. Dale zkontroluje jejich
 spravnost, co se tyce formalit, jako jestli v ciselnem udaji se nevyskytuji
 jine znaky nez cislice, atd. Procedure se zkonci, jen kdyz pouzijeme Esc
 nebo neco na ten zpusob, nebo se zkonci, kdyz vlozene udaje jsou formalne
 vporadku. Indikace, jestli mame zkoncit, se vraci v parametru 'zrusit_akci'}
procedure formular (var zrusit_akci :boolean;
                    var edit_autor, edit_nazev, edit_rok, edit_druh,
                    edit_cislo :string);
var
  orig_cislo :string;  {cislo pred editaci}
  zprava :string;      {sem nacpu text zpravy, pri chybe}
  obsahuje :boolean;   {vlajka, ze dany znak nasel}
  chyba :boolean;      {kdyz narazim na chybu, tak ji takto oznamim}
  prerusit :boolean;   {vlajka, ze bylo uzivatelem vyzadano preruseni}
  konec :boolean;
  konec_formular :boolean; {zda si uzivatel vyzadal ukonceni pres ESC, Zrusit}
  polozka :byte;

  buffer :pointer; {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;

  dil :real;            {kolik cyklu je 1%}
  procenta :real;
  proc_cel :byte;       {pocet % prave hotovych jiz zaokourhlenne}
  delta_ind :byte;      {kolik toho udelal od minula !! ve znacich}
  pozice :byte;         {kam ma nakreslit dalsi znak}

  aw, bw, cw :word;
  a, b, c :byte;
  o, upozorneni, kontrola :byte;
begin
  {inicializace}
  zrusit_akci := false;
  konec := false;
  upozorneni := 0;
  orig_cislo := edit_cislo;
 
  {nakresli okno}
  swcolor (7, 1);
  swsize (nid, 41, 12);
  swcenter (nid);
  {zobrazime titulkovy pruh podle parent_proces: 1..pridat, 2..editace}
  if parent_proces = 1 then swtitle (nid, 'Pidat novou knihu');
  if parent_proces = 2 then swtitle (nid, 'Editace daj o knize');
  openwindow (o);
  wjdina (0, 1);
  wpis (' Autor:                                  ');
  wjdina (0, 3);
  wpis (' Nzev:                                  ');
  wjdina (0, 5);
  wpis (' Rok:                                    ');
  wjdina (0, 7);
  wpis (' Druh:                                   ');
  wjdina (0, 9);
  wpis (' slo:                                  ');

  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('Enter');
  barva (7, 1);
  pis ('Potvrdit ');
  barva (1, 3);
  pis ('Tab,'+ #24 + ',' + #25);
  barva (7, 1);
  pis ('Pohyb v menu                                    ');}

  setexitkey ('');
  setfromctitonextallow (true);
  
  setallowedkey ('');
  setdisallowedkey ('*'); {hvezdicka se pouziva jako zastupny znak}
  addinputline (8, 1, @edit_autor, 30, 32);
  addinputline (8, 3, @edit_nazev, 30, 32);
  setallowedkey ('0123456789');
  addinputline (8, 5, @edit_rok, 4, 6);
  setallowedkey ('');
  addinputline (8, 7, @edit_druh, 1, 3);
  setallowedkey ('0123456789');
  addinputline (8, 9, @edit_cislo, 4, 6);
  
  addbutton (11, 11, 'OK');
  addbutton (24, 11, 'Zruit');
    

  {cyklus, ve kterem se zadavaji jednotlive udaje, najehoz konci se testuje
  formalni spravnost}
  a := 0;
  repeat
    obsahuje := false;
    chyba := false;
    changewindow (o);
    
    {vystavi formular na udaje o knize a necha nas doplnovat data}
    a := runaktip (a);
    {zjistuji, jak zkoncila procedura 'cti'}
    {kdyz to byl ESC, tak koncime}
    if exit_key = #27 then begin
      konec := true;
      konec_formular := true;
    end;
    {kdyz to byl Enter na tlacitku 'Zrusit'}
    if ((a = 6) and (exit_key = #13)) then begin
      konec := true;
      konec_formular := true;
    end;
    {kdyz to byl Enter na tlacitku 'OK'}
    if ((a = 5) and (exit_key = #13)) then begin
      konec := true;
      konec_formular := false;
    end;
    {F1}
    {if exit_key = #171 then begin
      napoveda ('udaje');
    end;}

    if upozorneni <> 0 then closewindow (upozorneni);
    konec := false;
    {*******************************************
     zjistuji, jak zkoncilo vyplnovani 'formulare'}
    {kdyz to byl ESC nebo Enter na Zrusit, tak koncime}
    if konec_formular = true then begin
      zrusit_akci := true;
      konec := true;
    end;
    {kdyz to byl Enter na 'OK'}
    if konec_formular = false then begin
      {provedu test na spravnost vlozenych udaju}
      {kdyz chybi nejaky udaj - treba chyby nazev knihy}
      if (edit_autor = '') or (edit_nazev = '') or (edit_rok = '')
         or (edit_druh = '') or (edit_cislo = '') then begin
         {zjistim, co predne neni vyplneno}
         if edit_cislo = '' then begin
           a := 4;
           zprava := '''slo''';
         end;
         if edit_druh = '' then begin
           a := 3;
           zprava := '''druh ''';
         end;
         if edit_rok = '' then begin
           a := 2;
           zprava := ''' rok ''';
         end;
         if edit_nazev = '' then begin
           a := 1;
           zprava := '''nzev''';
         end;
         if edit_autor = '' then begin
           a := 0;
           zprava := '''autor''';
         end;
         {zobrazim chybovou zpravu}
         swcolor (0, 3);
         swsize (nid, 52, 1);
         swposition (nid, center, 21);
         swtitle (nid, 'Upozornn');
   	 openwindow (upozorneni);
         wjdina (0, 0);
         wpis ('         daj ' + zprava + ' nen vyplnn!           ');

         {nastavim vlajky}
         chyba := true;
         konec := false;
      end;

      {kdyz je vse vyplneno spravne, tak otestujeme 'cislo', zda uz neni
       uzivano u nejak jine knihy
       Testovat se bude vzdy krome editace, pri niz se nemenilo 'cislo.}
      if (not chyba) then
        {testovat nebudem napr. je-li seznam prazdny 'pocet_knih = 0'}
        if (((parent_proces = 2) and (edit_cislo = orig_cislo)))
           or (pocet_knih = 0) then begin
          konec := true;
        end
        {testovat budem}
        else begin
          {inicializace}
          pozice := 0;
          prerusit := false;

          {ulozime pozadi}
          {ctiblok (0, 24, 79, 24, one_radek);}
          {zobrazim klavesn. napovedu}
          {jdina (0, 24);
          barva (7, 1);
          pis (' ');
          barva (1, 3);
          pis ('Esc');
          barva (7, 1);
          pis ('Zruit kontrolu                                                             ');}


          {zobrazim indikacni pas}
          swcolor (7, 1);
          swsize (nid, 54, 3);
          swcenter (nid);
          swtitle (nid, 'Kontrola');
          openwindow (kontrola);
          wjdina (0, 0);
          wpis ('            Kontrola duplicity ''sla''     ');
          wjdina (0, 1);
          wpis ('[__________________________________________________]');

          {testujeme}
          dil := (pocet_knih) / 100;
          aw := 0;
          obsahuje := false;

          repeat
            {zdrzuje}
            {for bw := 0 to 2000 do for cw := 0 to 2000 do;}

            {pracuje}
            if cislo^ [aw] = edit_cislo then begin {kdyz najde duplicitni cislo}
              obsahuje := true;
            end;

            {indikuje}
            procenta := (aw + 1) / dil;     {kolik % jiz udelal}
            proc_cel := trunc (procenta);{zaokrouhleno, kolik procent uz udelal}
            wjdina (24, 3);                {zobrazime %}
            wpisw (proc_cel);
            wpisz ('%');

            delta_ind := proc_cel shr 1;       {% delime 2;  1 znak = 2%}
            delta_ind := delta_ind - pozice;   {kolik znaku mame ted zobrzit}
            while delta_ind > 0 do begin        {kdyz ten rozdil je zobrzitelny}
              wjdina (1 + pozice, 2);
              wpisz ('#');
              pozice := pozice + 1;
              delta_ind := delta_ind - 1;
            end;

            {posuneme se dale}
            aw := aw + 1;

            {jestli nekdo nestisknul Esc pro preruseni}
            {if getkey = #27 then prerusit := true;}

          until (obsahuje) or (aw = pocet_knih) or (prerusit);

          {smaze indikacni pas}
          closewindow (kontrola);

          if obsahuje then begin
            {zobrazim chybovou zpravu}
            swcolor (0, 3);
            swsize (nid, 52, 1);
            swposition (nid, center, 21);
            swtitle (nid, 'Upozornn');
            openwindow (upozorneni);
            wjdina (0, 0);
            wpis ('      Kniha s tmto slem ji existuje!       ');

            a := 4;
            chyba := true;
            konec := false;
          end
          else konec := true;
        end;
    end;
  until konec;


  konec := false; {musim nastavit false, jinak by mi program okamzite zkoncil}
  klavesa := #0; {nutne, jinak nam program vyhodi editaci}
  closewindow (o);
  {changewindow (root);}
end;






{************************************************************************
 ****************************************
 Tato procedure vystavi formular pro HLEDANI KNIHY. Dale zkontroluje jejich
 spravnost, co se tyce formalit, jako jestli v ciselnem udaji se nevyskytuji
 jine znaky nez cislice, atd. a odmaze duplicitni hvezdicky. Procedure se
 zkonci, jen kdyz pouzijeme Esc nebo neco na ten zpusob, nebo se zkonci,
 kdyz vlozene udaje jsou formalne vporadku. Indikace, jestli je vynuceno
 zruseni, se vraci v parametru 'zrusit_akci'. Parametry 'lfind_autor', ...
 vraceji modifikovane filtry jen pri zrusit_akci = false}
procedure formularfind (var zrusit_akci :boolean;
                        var lfind_autor, lfind_nazev, lfind_druh, lfind_rok,
                            lfind_cislo :string);

var
  orig_cislo :string;  {cislo pred editaci}
  zprava :string;      {sem nacpu text zpravy, pri chybe}
  obsahuje :boolean;   {vlajka, ze dany znak nasel}
  chyba :boolean;      {kdyz narazim na chybu, tak ji takto oznamim}
  prerusit :boolean;   {vlajka, ze bylo uzivatelem vyzadano preruseni}
  konec :boolean;
  konec_formular :boolean; {zda si uzivatel vyzadal ukonceni pres ESC, Zrusit}
  polozka :byte;

  {buffer :array [0..1203] of byte;} {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;

  dil :real;            {kolik cyklu je 1%}
  procenta :real;
  proc_cel :byte;       {pocet % prave hotovych jiz zaokourhlenne}
  delta_ind :byte;      {kolik toho udelal od minula !! ve znacich}
  pozice :byte;         {kam ma nakreslit dalsi znak}

  aw, bw, cw :word;
  a, b, c :byte;
  o :byte;

  {*********************************************************
   Provadi korekci lfind_autor, ... - odmaze nadbytecne '*'}
  procedure delrepstars (var retezec :string);
  var
    b, c, d, e :byte;

  begin
    {inicializace}
    b := 0;

    repeat
      b := b + 1;
      {najdeme-li 1 hvezdicku}
      if retezec [b] = '*' then begin
        {projizdime dal dokud nezkonci retezec souvislych hvezdicek}
        for c := b to length (retezec) do
          if retezec [c] <> '*' then break;

        {kdyz jsme breakem vubec nezkoncili, ale az do konce jsou hvezdicky}
        if (c = length (retezec))
           and (retezec [length (retezec)] = '*') then e := 1
        else e:= 0;

        {kdyz nasel sousedni}
        if c > (b + 1 - e) then begin
          {vypustime hvezdicky az na jednu}
          for d := (c - 1) to (length (retezec) - e) do
            retezec [b + d - c + 1] := retezec [d];
          retezec [0] := char (length (retezec) - (c - b - 1) - e);
        end;
      end;
    until b >= length (retezec);
  end;


begin
  {inicializace}
  zrusit_akci := false;
  konec := false;
  a := 0;

  {ulozime pozadi}
  {ctiblok (18, 5, 60, 18, buffer);}
  {ctiblok (0, 24, 79, 24, one_radek);}

  {zobrazime okno}
  swcolor (7, 1);
  swsize (nid, 41, 12);
  swcenter (nid);
  {zobrazime titulkovy pruh podle parent_proces: 1..pridat, 2..editace}
  if parent_proces = 1 then swtitle (nid, 'Oznait knihy');
  if parent_proces = 2 then swtitle (nid, 'Zruit ozanaen u knih');
  if parent_proces = 3 then swtitle (nid, 'Najt knihy');
  openwindow (o);
  
  wjdina (0, 1);
  wpis (' Autor:                                  ');
  wjdina (0, 3);
  wpis (' Nzev:                                  ');
  wjdina (0, 5);
  wpis (' Rok:                                    ');
  wjdina (0, 7);
  wpis (' Druh:                                   ');
  wjdina (0, 9);
  wpis (' slo:                                  ');
 
  setexitkey ('');
  setallowedkey ('');
  setdisallowedkey ('');
  addinputline (8, 1, @lfind_autor, 30, 32);
  addinputline (8, 3, @lfind_nazev, 30, 32);
  setallowedkey ('0123456789');
  addinputline (8, 5, @lfind_rok, 4, 6);
  setallowedkey ('');
  addinputline (8, 7, @lfind_druh, 1, 3);
  setallowedkey ('0123456789');
  addinputline (8, 9, @lfind_cislo, 4, 6);
  addbutton (10, 11, 'OK');
  addbutton (23, 11, 'Zruit');

  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('Enter');
  barva (7, 1);
  pis ('Potvrdit ');
  barva (1, 3);
  pis ('Tab,'+ #24 + ',' + #25);
  barva (7, 1);
  pis ('Pohyb v menu                                    ');}


  {cyklus, ve kterem se zadavaji jednotlive udaje, najehoz konci se testuje
  formalni spravnost}
  repeat
    obsahuje := false;
    chyba := false;
    {vystavi formular na udaje o knize a necha nas doplnovat data}
    {rozbor klaves}
    a := runaktip (a);

    {zjistuji, jak zkoncila procedura 'cti'}
    {kdyz to byl ESC, tak koncime}
    if exit_key = #27 then begin
      konec := true;
      konec_formular := true;
    end;
    {kdyz to byl Enter na tlacitku 'Zrusit'}
    if ((a = 6) and (exit_key = #13)) then begin
      konec := true;
      konec_formular := true;
    end;
    {kdyz to byl Enter na tlacitku 'OK'}
    if ((a = 5) and (exit_key = #13)) then begin
      konec := true;
      konec_formular := false;
    end;
    {F1}
    {if exit_key = #171 then begin
      napoveda ('maska');
    end;}


    konec := false;
    {*******************************************
     zjistuji, jak zkoncilo vyplnovani 'formulare'}
    {kdyz to byl ESC nebo Enter na Zrusit, tak koncime}
    if konec_formular = true then begin
      zrusit_akci := true;
      konec := true;
    end;
    {kdyz to byl Enter na 'OK'}
    if konec_formular = false then begin
      {provedu test na spravnost vlozenych udaju}
      {kdyz chybi nejaky udaj - treba chyby nazev knihy tak tam narvem '*'}
      if lfind_cislo = '' then lfind_cislo := '*';
      if lfind_druh = '' then lfind_druh := '*';
      if lfind_rok = '' then lfind_rok := '*';
      if lfind_nazev = '' then lfind_nazev := '*';
      if lfind_autor = '' then lfind_autor := '*';

      {prohlednu zdvojene kvezdicky - nesmi se vyskytovat vice hvezdicek
       za sebou - u lfind_druh neni treba - je to jen 1 znak}
      delrepstars (lfind_autor);
      delrepstars (lfind_nazev);
      delrepstars (lfind_rok);
      delrepstars (lfind_cislo);

      {kdyz je vse vyplneno spravne}
      if not chyba then begin
        konec := true;
      end;
    end;
  until konec;

  {obnovime pozadi}
  {pisblok (18, 5, 60, 18, buffer);}
  {pisblok (0, 24, one_radek, true);}

  konec := false; {musim nastavit false, jinak by mi program okamzite zkoncil}
  klavesa := #0; {nutne, jinak nam program vyhodi editaci}
  closewindow (o);
end;




{************************************************************************
 ****************************************
 Pouziva metodu QuickSort
 parametr 'misto' vraci cislo, na kterem miste v ''abc_total' by melo byt
 zarazene}
procedure tridit (var zrusit_akci :boolean; var misto :word;
                  edit_autor, edit_nazev, edit_rok, edit_druh,
                  edit_cislo :string);
var
  minimum, maximum :word; {vymezuje podmnozinu, v ktere se bude hledat}
  pul :word;              {rozdeli podmnozinu na 2 poloviny}
  compare :byte;   {vysledek porovnani: 1 mensi, 2 stejne, 3 vetsi}

  buffer :pointer; {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;
  klavesa :char;

  dil, procenta :real; {na indikaci}
  proc_cel, delta_ind, pozice :byte;
  prerusit :boolean;
  aw : word;
  bw, cw :word; {jen na zdrzeni}
  o :byte;
{*********}
function stringcompare (first, second :string): byte; {1 mensi, 2 stejne,
                                                       3 vetsi}
var
  delka_min, delka_first, delka_second :byte;
  compare :byte;
  a :byte;

begin
  stringcompare := 2; {predpoklada, ze jsou stejne}
  compare := 2;
  delka_first := length (first);
  delka_second := length (second);
  if delka_first < delka_second then delka_min := delka_first
  else delka_min := delka_second;

  for a := 1 to delka_min do begin
    {mensi}
    if abeceda [ord (first [a])] < abeceda [ord (second [a])] then begin
      stringcompare := 1;
      compare := 1;
      a := delka_min; {aby zkoncil}
    end
    else begin
      {vetsi}
      if abeceda [ord (first [a])] > abeceda [ord (second [a])] then begin
        stringcompare := 3;
        compare := 3;
        a := delka_min; {aby zkoncil}
      end;
      {stejeny znak -> bude se opakovat}
    end;
  end;
  {nenasel rozdil -> podiva se na jejich delku}
  if compare = 2 then begin
    if delka_first < delka_second then stringcompare := 1;
    if delka_first > delka_second then stringcompare := 3;
  end;
end;

{********* Porovna 2 knihy}
function bookcompare (compared_book :word): byte; {1 mensi, 2 stejne,
                                                       3 vetsi}
var
  compare :byte;
begin
  compare := stringcompare (edit_autor, autor^ [compared_book]);
  if compare = 2 then begin
    compare := stringcompare (edit_nazev, nazev^ [compared_book]);
    if compare = 2 then begin
      compare := stringcompare (edit_rok, rok^ [compared_book]);
      if compare = 2 then begin
        compare := stringcompare (edit_druh, druh^ [compared_book]);
        if compare = 2 then begin
          compare := stringcompare (edit_cislo, cislo^ [compared_book]);
        end;
      end;
    end;
  end;
  bookcompare := compare;
end;

{**********
 Vypocita log (2) X a zaokrouhli jej nahoru. Pouziva bitoveho posunu}
function rounduplog2 (x :word) :word;
var
  dve_na_n :word;
  n : word;
begin
  n := 0;
  dve_na_n := 1;

  while dve_na_n < x do begin
    n := n + 1;
    dve_na_n := dve_na_n shl 1;
  end;

  rounduplog2 := n;
end;


{**********}
begin
  {ulozime pozadi}
  {ctiblok (0, 24, 79, 24, one_radek);}
  {zobrazim klavesn. napovedu}
  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit kontrolu                                                             ');}

  {zobrazim indikacni pas}
  swcolor (7, 1);
  swsize (nid, 52, 3);
  swtitle (nid, 'Tdn');
  swcenter (nid);
  openwindow (o);
  wjdina (0, 0);
  wpis ('            Zaazuji knihu podle abecedy            ');
  wjdina (0, 1);
  wpis ('[__________________________________________________]');

  zrusit_akci := false;

  {priprava na indikaci}
  dil := (rounduplog2 (pocet_knih)) / 100;
    if dil = 0 then dil := 1;  {korekce, jinak nam vyhodi DIVIZION BY ZERO}
  aw := 0;
  pozice := 0;  {! tady je nutne inicializovat}
  prerusit := false;
  {obsahuje := false;}


  {trididici algoritmus}
  minimum := 0;
  maximum := pocet_knih - 1;
  repeat

    {pracuje}
    pul := (maximum - minimum) div 2 + minimum; {urcim prostredek base}
    {porovnam 2 knihy}
    compare := bookcompare (abc_total^ [pul]);
    {new je nekde v leve pulce baze}
    if compare = 1 then maximum := pul;
    {new je nekde v prave pulce baze}
    if (compare = 3) or (compare = 2) then minimum := pul;


    {indikace}
      {zdrzuje}
      {cekej (500);}

      {indikuje}
      procenta := (aw + 1) / dil;     {kolik % jiz udelal}
      proc_cel := trunc (procenta);  {tady mame zaokrouhleno, kolik procent toho
                                      uz udelal}
      wjdina (24, 2);                {zobrazime %}
      wpisw (proc_cel);
      wpisz ('%');

      delta_ind := proc_cel shr 1;       {% delime 2;  1 znak = 2%}
      delta_ind := delta_ind - pozice;   {kolik znaku mame ted zobrazit}
      while delta_ind > 0 do begin        {kdyz ten rozdil je zobrzitelny}
        wjdina (1 + pozice, 1);
        wpisz ('#');
        pozice := pozice + 1;
        delta_ind := delta_ind - 1;
      end;

      {posuneme se dale}
      aw := aw + 1;

      {jestli nekdo nestisknul Esc pro preruseni}
      {if getkey = #27 then prerusit := true;}


  until (maximum - minimum) < 2; {zkoncime, zustaneli jen 1 prvek}
  {provadim posledni test na zjisteni 'mista'}
  {edit_kniha prijde hned doleva (pred) misto}
  if compare = 1 then begin
     if maximum <> 0 then begin
       compare := bookcompare (abc_total^ [maximum - 1]); {porovnam}
       if compare = 1 then maximum := maximum - 1;
     end;
    misto := maximum;
  end
  {'new' prijde hned doprava (po) misto}
  else begin
    compare := bookcompare (abc_total^ [minimum + 1]); {porovnam}
    if compare = 3 then minimum := minimum + 1;
    misto := minimum + 1
  end;

  {vypis}
  {pisw (misto);}
  {repeat
    klavesa := getkey;
  until klavesa <> #0;}

  {smaze indikacni pas}
  closewindow (o);
  {pisblok (0, 24, one_radek, true);}
end;



{****************************************
 ****************************************
 'find_string' je maska, 'substrat' je retezec, v kterem se hlededa.
 Vystupem je boolean: TRUE ... odpovida masce; FALSE ... neodpovida

 !!! neni implementovana ochrana pred spatnou syntaxi find_string;
 spravna syntaxe:  vzdy alespon 1 znak
                   zasebou nesmi byt vice hvezdicek
 !!!
 Proto je nutne v procedure 'findformular' provest korekci 'findstring'
 pomoci procedury 'delrepstars'}
function maskstring (find_string, substrat :string) :boolean;
var
  sub_find :string;  {souvisly retezev bez hvezdicek}
  obsahuje, obsahuje_2, nehledat :boolean;

  a, b, c, y, z :word;

begin
  {inicializace}
  maskstring := false;
  obsahuje := true;
  nehledat := false;


  {Testujeme, zda find_string = '*'. Kdyz jo, tak neni treba se tim tak
   do hloubky zaobirat}
  if find_string = '*'then begin
    maskstring := true;
    exit;
  end;


  {hledame na zacatku}
  {nezacina '*'}
  if find_string [1] <> '*' then begin

    {extrahujeme sub_find z find_string}
    sub_find := '';
    for z := 1 to length (find_string) do
      if find_string [z] <> '*' then sub_find := sub_find + find_string [z]
      else break;

    {odmazame ze zacatku find_stringu sub_find ... posuneme na zacatek}
    {!kdyz jsme nezkoncili breakem ... prekopirovali jsem cely find_string,
     tak find_string vynulujeme}
    if (z = length (find_string)) and (find_string [z] <> '*') then
      find_string [0] := #0
    else begin
      for y := z to length (find_string) do
        find_string [y - z + 1] := find_string [y];
      find_string [0] := char (length (find_string) - z + 1);
    end;

    {prohledame, jestlize sub_find je <= nez substrat}
    if length (sub_find) <= length (substrat) then begin
      {je-li find_string nenulovy}
      if find_string <> '' then begin
        for a := 1 to length (sub_find) do begin
          {rozdilna pismenka}
          if substrat [a] <> sub_find [a] then begin
            obsahuje := false;
            break
          end;
        end;
        b := a + 1; {kde jsme zkoncili + 1, takze spis, kde budeme zacinat}
      end
      {je-li prazdny -> musi se cele shodovat}
      else begin
        if sub_find <> substrat then obsahuje := false;
        nehledat := true; {vlajka, ze nemame hledat od konce}
      end;
    end

    {je-li delsi}
    else obsahuje := false;

  end
  {zacina '*'}
  else begin
    b := 1;
    obsahuje := true;
  end;


  {hledame uprostred - musi byt obklopeno hvezdickami
   Tento blok programu prohledava retezce obklopene hvezdizkami}
  if (obsahuje) and (find_string [1] = '*') and (length (find_string) > 1)
    then begin

    {extrahujeme sub_find z find_string, odmazeme '*' na zacatku}
    sub_find := '';
    for z := 2 to length (find_string) do
      if find_string [z] <> '*' then sub_find := sub_find + find_string [z]
      else break;


    {musi nasledovat hvezdicka ve find_string
     Tento cyklus se opakuje stale kdyz vzdy najde & nasledujici je '*'.
     Podminka (z < length (find_string)) zajistuje, aby ta pozadovana
     hvezdicka nebyla az za retezcem - jen tak nekde mimo promennou}
    {if (obsahuje) and (find_string [z] = '*') and (z < length (find_string))
      then begin}
    while (obsahuje) and (find_string [z] = '*') and
          (z <= length (find_string)) do begin

      {odmazame ze zacatku find_stringu sub_find ... posuneme na zacatek}
      for y := z to length (find_string) do
        find_string [y - z + 1] := find_string [y];
      find_string [0] := char (length (find_string) - z + 1);

      {hledame}
      for a := b to length (substrat) do begin
        {sub_find se musi vejit do substratu}
        if length (sub_find) <= length (substrat) - a + 1 then begin
          obsahuje_2 := true;
          for c := 1 to length (sub_find) do begin
            {neshoduji se pismenka}
            if substrat [a + c - 1] <> sub_find [c] then begin
              obsahuje_2 := false;
              break;
            end;
          end;
        end;
        if obsahuje_2 then begin
          b := a + 1; {kde jsme zkoncili + 1, takze spis, kde budeme zacinat}
          break;
        end;
      end;

      {extrahujeme sub_find z find_string}
      sub_find := '';
      for z := 2 to length (find_string) do
      if find_string [z] <> '*' then sub_find := sub_find + find_string [z]
      else break;

      {nastavim obsahuje, ze tento sub_find nasel a muze hledat dal}
      if obsahuje_2 then obsahuje := true
      else obsahuje := false;
    end;

  end;


  {Hledame na konci - na konci find_stringu nesmi byt '*' & nesmeli se cele
   uz porovnavat v sekci 'hledam od zacatku' ... nehledat = false}
  if (obsahuje) and (not nehledat)
     and (find_string [length (find_string)] <> '*')
    then begin

    {hledame, find_string se musi vejit do jeste neprohledaneho zbytku
    substratu ... mezi 'b' a konec}
    if (length (find_string) <= (length (substrat) - b + 1)) then begin
      c := length (substrat); {jen pro zrychleni}
      {hledame od konce}
      for a := length (sub_find) downto 1 do begin
        {rozdilna pismenka}
        if substrat [c] <> sub_find [a] then begin
          obsahuje := false;
          break
        end;
        c := c - 1;
      end;
    end

    {nevesel se}
    else begin
      obsahuje := false;
    end;

  end;

  if obsahuje then maskstring := true;

end;




{****************************************
 ****************************************
 Tato procedura otestuje masku postupne na vsech knihach a vrati jejich
 seznam}

procedure testujmasku (var pocet :word; var odpovidaji :array of word;
                       find_autor, find_nazev :string; find_druh :char;
                       finf_rok, find_cislo :string);
var
  buffer :pointer; {pamet pro ulozeni obsahu obrazovky}
  one_radek :pointer;
  klavesa :char;

  dil, procenta :real; {na indikaci}
  proc_cel, delta_ind, pozice :byte;
  prerusit :boolean;
  aw : word;
  bw, cw :word; {jen na zdrzeni}
  o :byte;
begin
  {inicializace}
  pocet := 0;
  pozice := 0;
  prerusit := false;

  {ulozime pozadi}
  {ctiblok (0, 24, 79, 24, one_radek);}
  {zobrazim klavesn. napovedu}
  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit kontrolu                                                             ');}


  {zobrazim indikacni pas}
  swcolor (7, 1);
  swsize (nid, 52, 3);
  swtitle (nid, 'Hledn');
  swcenter (nid);
  openwindow (o);
  
  wjdina (0, 0);
  wpis ('          Hledm knihy odpovdajc zadn          ');
  wjdina (0, 1);
  wpis ('[__________________________________________________]');

  {urcime 1%}
  dil := (pocet_knih) / 100;
  aw := 0;
  {obsahuje := false;}

  repeat
    {zdrzuje}
    {for bw := 0 to 2000 do for cw := 0 to 2000 do;}

    {vypis}
    {jdina (0, 1);
    pis ('F: ');
    pis (find_autor);
    jdina (0, 2);
    pis ('S: ');
    pisw (aw);
    pis (':');
    pis (autor^ [aw]);}

    {pracuje}
    {testuje masku na vsech atributech (autor & nazev & ...}
    if maskstring (find_autor, autor^ [aw]) then
      if maskstring (find_nazev, nazev^ [aw]) then
        if (find_druh = '*') or (find_druh = druh^ [aw]) then
          if maskstring (find_rok, rok^ [aw]) then
            if maskstring (find_cislo, cislo^ [aw]) then
              begin
                odpovidaji [pocet] := aw;
                pocet := pocet + 1;
              end;

    {indikuje}
    procenta := (aw + 1) / dil;     {kolik % jiz udelal}
    proc_cel := trunc (procenta);  {tady mame zaokrouhleno, kolik procent toho
                                    uz udelal}
    wjdina (24, 2);                {zobrazime %}
    wpisw (proc_cel);
    wpisz ('%');

    delta_ind := proc_cel shr 1;       {% delime 2;  1 znak = 2%}
    delta_ind := delta_ind - pozice;   {kolik znaku mame ted zobrzit}
    while delta_ind > 0 do begin        {kdyz ten rozdil je zobrzitelny}
      wjdina (1 + pozice, 1);
      wpisz ('#');
      pozice := pozice + 1;
      delta_ind := delta_ind - 1;
    end;
    
    {wait (100);}
    {if aw > pocet_knih - 5 then getkey;}

    {posuneme se dale}
    aw := aw + 1;

    {jestli nekdo nestisknul Esc pro preruseni}
    {if getkey = #27 then prerusit := true;}

  until (aw = pocet_knih) or (prerusit);
  {smaze indikacni pas}
  {pisblok (13, 10, buffer, true);
  pisblok (0, 24, one_radek, true);}
  klavesa := #0;
  closewindow (o);
end;






{****************************************
 ****************************************}
procedure pridatknihu;
var
  edit_autor,
  edit_nazev,
  edit_rok,
  edit_druh,
  edit_cislo :string;

  misto :word; {kam se ma zaradit nova kniha}

  zrusit_akci :boolean;
  konec :boolean;
  a, b, c :word;


begin
  if pocet_knih >= maximalni_pocet_knih then exit;
  {inicializace}
  parent_proces := 1;

  edit_autor := '';
  edit_nazev := '';
  edit_rok := '';
  edit_druh := '';
  edit_cislo := '';



  konec := false;


  {volam proceduru na vyplneni formulare}
  formular (zrusit_akci, edit_autor, edit_nazev, edit_rok, edit_druh,
              edit_cislo);

  {kdyz vse je v poradku, muzeme zaclenit knihu do databaze}
  if zrusit_akci = false then begin

    {neni-li databaze prazdna, ma smysl zarazovat dle abecedy}
    if pocet_knih <> 0 then begin
      {urcujeme poradi knihy dle abecedy}
      tridit (zrusit_akci, misto, edit_autor, edit_nazev, edit_rok, edit_druh,
                edit_cislo);

      {zapisujeme do 'abc_total'}
      for a := (pocet_knih - 1) downto misto do
        abc_total^ [a + 1] := abc_total^ [a];
      abc_total^ [misto] := pocet_knih;
    end
    {prazdna databaze -> zapiseme 1. poradi v abacede}
    else begin
      {zapisujeme do 'abc_total'}
      abc_total^ [0] := 0;
    end;

    {zapisujeme do databaze}
    autor^ [pocet_knih] := edit_autor;
    nazev^ [pocet_knih] := edit_nazev;
    rok^ [pocet_knih] := edit_rok;
    druh^ [pocet_knih] := edit_druh [1];
    cislo^ [pocet_knih] := edit_cislo;
    oznacen^ [pocet_knih] := 0;
    pocet_knih := pocet_knih + 1;

    {aby nezapomnel ulozit}
    modifikovano := true;
  end;


  konec := false; {musim nastabit false, jinak by mi program okamzite zkoncil}
  klavesa := #0; {nutne, jinak nam program vyhodi editaci}
{  barva (7, 1);
  jdina (0, 24);
  pisblok (0, 24, hlavni_klavesova_napoveda, false);}
end;



{****************************************
 ****************************************}
procedure editovatknihu;
var
  edit_autor,
  edit_nazev,
  edit_rok,
  edit_druh,
  edit_cislo :string;
  misto :word;  {kam prijde zaradit nova kniha}
  puvodni_abc_total :word; {puvodni hodnota 'abc_total' na 'aktualni'}

  zrusit_akci :boolean;
  konec :boolean;
  a, b :byte;
begin
  if pocet_knih = 0 then exit;
  parent_proces := 2;


  puvodni_abc_total := abc_total^ [aktualni];

  {predavam hodnoty ze seznamu}
  edit_autor := autor^ [abc_total^ [aktualni]];
  edit_nazev := nazev^ [abc_total^ [aktualni]];
  edit_rok   := rok^ [abc_total^ [aktualni]];
  edit_druh  := druh^ [abc_total^ [aktualni]];
  edit_cislo := cislo^ [abc_total^ [aktualni]];

  konec := false;

  a := 1;
  {cylkus na vyplneni formulare}
    {vystvi formular na udaje o knize}
  formular (zrusit_akci, edit_autor, edit_nazev, edit_rok, edit_druh,
            edit_cislo);

  {testujeme, jestli se vubec neco zmenilo, jinak nema cenu dal pokracovat}
  if (edit_autor = autor^ [abc_total^ [aktualni]])
     and (edit_nazev = nazev^ [abc_total^ [aktualni]])
     and (edit_rok   = rok^ [abc_total^ [aktualni]])
     and (edit_druh  = druh^ [abc_total^ [aktualni]])
     and (edit_cislo = cislo^ [abc_total^ [aktualni]])
     then zrusit_akci := true;

  if not zrusit_akci then
    {urcujeme poradi knihy dle abecedy}
    tridit (zrusit_akci, misto, edit_autor, edit_nazev, edit_rok, edit_druh,
            edit_cislo);

  if zrusit_akci = false then begin

    {vlozime novou knihu -> tedy tam zustane i ta stara}
    for a := (pocet_knih - 1) downto misto do
      abc_total^ [a + 1] := abc_total^ [a];
    abc_total^ [misto] := puvodni_abc_total;


    {starou vymazeme, nutne rozlisit, kde je nova}
    {stara napravo od nove}
    if misto <= aktualni then begin
      for a := (aktualni + 1) to (pocet_knih - 1) do
        abc_total^ [a] := abc_total^ [a + 1];
      abc_total^ [pocet_knih] := 65535;  {!!!!NUTNE MODIFIKOVAT}
    end
    {stara nalevo od nove}
    else begin
      for a := (aktualni) to (pocet_knih - 1) do
        abc_total^ [a] := abc_total^ [a + 1];
      abc_total^ [pocet_knih] := 65535; {!!!!NUTNE MODIFIKOVAT}
    end;


    {vracim hodnoty do seznamu}
    autor^ [puvodni_abc_total] := edit_autor;
    nazev^ [puvodni_abc_total] := edit_nazev;
    rok^ [puvodni_abc_total]   := edit_rok  ;
    druh^ [puvodni_abc_total]  := edit_druh [1];
    cislo^ [puvodni_abc_total] := edit_cislo;

    {aby nezapomnel ulozit}
    modifikovano := true;
  end;

  konec := false; {musim nastabit false, jinak by mi program okamzite zkoncil}
  klavesa := #0; {nutne, jinak nam program vyhodi editaci}
{ barva (7, 1);
  jdina (0, 24);
  pisblok (0, 24, hlavni_klavesova_napoveda, false);}
end;



{****************************************
 ****************************************}
procedure smazatknihu;
var
  a :byte;
  vysledek :boolean;
  one_radek :pointer;
  o :byte;
begin
  if pocet_knih = 0 then exit;
  {zobrazim okno}
  swcolor (7, 1);
  swsize (nid, 52, 8);
  swcenter (nid);
  swtitle (nid, 'Smazat knihu');
  openwindow (o);
  
  wjdina (0, 1);
  wpis ('                 Smazat tuto knihu?                 ');
  wjdina (0, 3);
  wpis (' Autor:                                 Druh:       ');
  wjdina (0, 4);
  wpis (' Nzev:                                 slo:      ');
  wjdina (0, 5);
  wpis (' Rok:                                               ');
  
  addbutton (15, 7, 'Ano');
  addbutton (34, 7, 'Ne');

  wbarva (10, 1);
  wjdina (8, 3);
  wpis (autor^ [abc_total^ [aktualni]]);
  wjdina (8, 4);
  wpis (nazev^ [abc_total^ [aktualni]]);
  wjdina (8, 5);
  wpis (rok^ [abc_total^ [aktualni]]);
  wjdina (47, 3);
  wpis (druh^ [abc_total^ [aktualni]]);
  wjdina (47, 4);
  wpis (cislo^ [abc_total^ [aktualni]]);

  {ctiblok (0, 24, 79, 24, one_radek);}
  {jdina (0, 24);
  barva (7, 1);
  pis (' ');
  barva (1, 3);
  pis ('Esc');
  barva (7, 1);
  pis ('Zruit ');
  barva (1, 3);
  pis ('Enter');
  barva (7, 1);
  pis ('Potvrdit ');
  barva (1, 3);
  pis ('Tab,'+ #27 + ',' + #26);
  barva (7, 1);
  pis ('Pohyb v menu                                    ');}


  {inicializace}
 
  a := runaktip (0);
  if (exit_key = #13) and (a = 0) then vysledek := true {cheme smazat knihu}
  else vysledek := false;

  {mazeme knihu: posledni knihu presuneme na aktualni knihu}
  if vysledek then begin

    {je-li v seznamu vice nez 1 kniha}
    if pocet_knih > 1 then begin
      if oznacen^ [abc_total^ [aktualni]] = 1 then
        pocet_oznacen := pocet_oznacen - 1;
      {mazeme-li zprostred seznamu}
      if abc_total^ [aktualni] <> (pocet_knih - 1) then begin
        {presuneme posledni knihu na misto smazane}
        autor^ [abc_total^ [aktualni]]   := autor^ [pocet_knih - 1];
        nazev^ [abc_total^ [aktualni]]   := nazev^ [pocet_knih - 1];
        rok^ [abc_total^ [aktualni]]     := rok^ [pocet_knih - 1];
        druh^ [abc_total^ [aktualni]]    := druh^ [pocet_knih - 1];
        cislo^ [abc_total^ [aktualni]]   := cislo^ [pocet_knih - 1];
        oznacen^ [abc_total^ [aktualni]] := oznacen^ [pocet_knih - 1];

        {presunutou knihu vymazeme - jen pro poradek}
        autor^ [pocet_knih - 1] := '';
        nazev^ [pocet_knih - 1] := '';
        rok^ [pocet_knih - 1] := '';
        druh^ [pocet_knih - 1] := ' ';
        cislo^ [pocet_knih - 1] := '';
        oznacen^ [pocet_knih - 1] := 0;

        {modifikjeme 'abc_total', protoze jsem presunuli z konce knihu}
        {nejdrive najdeme hodnotu 'pocet_knih - 1' v abc_total}
        for a := 0 to (pocet_knih - 1) do begin
          if abc_total^ [a] = (pocet_knih - 1) then begin
            abc_total^ [a] := abc_total^ [aktualni]; {zmodifikujeme}
            a := pocet_knih - 1;       {abychom ukoncili smycku FOR}
          end;
        end;
        {posuneme cast 'abc_total', protoze jsme 1 knihu vypustili}
        for a := (aktualni)  to (pocet_knih - 2) do
          abc_total^ [a] := abc_total^ [a + 1];
      end
      {mazeme-li z konce seznamu}
      else begin
        autor^ [pocet_knih - 1] := '';
        nazev^ [pocet_knih - 1] := '';
        rok^ [pocet_knih - 1] := '';
        druh^ [pocet_knih - 1] := ' ';
        cislo^ [pocet_knih - 1] := '';
        oznacen^ [pocet_knih - 1] := 0;

        {posuneme cast 'abc_total', protoze jsme 1 knihu vypustili}
        for a := (aktualni)  to (pocet_knih - 2) do
          abc_total^ [a] := abc_total^ [a + 1];
      end;

      {poseneme kurzor o 1 knihu nahoru}
      jdioknihunahoru;

      {snizime pocet knih}
      pocet_knih := pocet_knih - 1;
    end
    {je-li tam prave 1 kniha}
    else begin
        autor^ [0] := '';
        nazev^ [0] := '';
        rok^ [0] := '';
        druh^ [0] := ' ';
        cislo^ [0] := '';
        oznacen^ [0] := 0;

        abc_total^ [0] := 65535;  {!!!NUTNE MODIFIKOVAT}
        virtualni := 0;
        aktualni := 0;
        pocet_knih := 0;
    end;

    {aby nezapomnel ulozit}
    modifikovano := true;
  end;

  {pisblok (0, 24, one_radek, true);}
  closewindow (o);
  klavesa := #0;
end;



{****************************************
 ****************************************}
function prazdnaknihovna :byte;
var
  a, o :byte;
begin
  swcolor (0, 3);
  swsize (nid, 43, 2);
  swcenter (nid);
  swtitle (nid, 'Upozornn');
  openwindow (o);
  wjdina (0, 0);
  wpis ('         V seznamu nen dna kniha!           ');
  wjdina (0, 1);
  wpis ('          Prosm, vlote 1. knihu.             ');
  prazdnaknihovna := o;
  changewindow (root);
end;



{****************************************
 ****************************************
 Oznaci ci odznaci knihu}
procedure oznacitknihu;
begin
  if pocet_knih = 0 then exit;
  {odznacena = 0}
  if oznacen^ [abc_total^ [aktualni]] = 0 then begin
    oznacen^ [abc_total^ [aktualni]] := 1;
    pocet_oznacen := pocet_oznacen + 1;
  end
  {oznacena = 1}
  else begin
    oznacen^ [abc_total^ [aktualni]] := 0;
    pocet_oznacen := pocet_oznacen - 1;
  end;

  klavesa := #0;
end;


{****************************************
 ****************************************
 Oznacene knihy odznaci, neoznacene oznaci}
procedure inverzeoznaceni;
var
  a :word;
begin
  if pocet_knih = 0 then exit;
  for a := 0 to (pocet_knih - 1) do
    if oznacen^ [a] = 0 then oznacen^ [a] := 1   {inverze}
    else oznacen^ [a] := 0;
  pocet_oznacen := pocet_knih - pocet_oznacen; {korekce poctu}

end;


{****************************************
 ****************************************
 Ozaci navic knihy, kt. odpovidaji filtru}
procedure oznacitfiltr;
var
  lfind_autor,         {slouzi k vyplneni dotazniku, jen docasne}
  lfind_nazev,
  lfind_rok,
  lfind_druh,
  lfind_cislo :string;

  zrusit_akci :boolean; {zda neni vynuceno preruseni}

  odpovidaji_knihy :array [0..799] of word;  {!!!!! NUTNE DOLADIT}
                                           {seznam knih, kt. masce odpovidaji}
  pocet_odpovida :word;   {pocet knih ve vracenem seznamu}

  aw, bw :word;

begin
  if pocet_knih = 0 then exit;
 
  {predavame 'find' masky}
  lfind_autor := find_autor;
  lfind_nazev := find_nazev;
  lfind_rok   := find_rok;
  lfind_druh  := find_druh;
  lfind_cislo := find_cislo;

  {inicializace}
  zrusit_akci := false;
  parent_proces := 1;

  {vystavi formular na masky}
  formularfind (zrusit_akci,
                lfind_autor, lfind_nazev, lfind_druh, lfind_rok, lfind_cislo);

  {kdyz budeme pokracovat}
  if not zrusit_akci then begin
    {aktualizujeme 'find' masky}
    find_autor := lfind_autor;
    find_nazev := lfind_nazev;
    find_rok   := lfind_rok;
    find_druh  := lfind_druh [1];
    find_cislo := lfind_cislo;

    {testujeme masky}
    testujmasku (pocet_odpovida, odpovidaji_knihy,
                 find_autor, find_nazev, find_druh, find_rok, find_cislo);
    {vypis}
    {jdina (0, 10);
    pis ('pocet_odpovida: ');
    pisw (pocet_odpovida);
    getkey;}

    {nastavime oznaceni}
    if pocet_odpovida > 0 then
      for aw := 0 to (pocet_odpovida - 1) do begin
        bw := odpovidaji_knihy [aw]; {predvypocet}
        {kniha nebyla predtim oznacena} 
        if oznacen^ [bw] = 0 then begin
          oznacen^ [bw] := 1;
          pocet_oznacen := pocet_oznacen + 1;
        end;
      end;
  end;

  {repeat
    klavesa := getkey;
  until klavesa <> #0;}

  klavesa := #0;
end;




{****************************************
 ****************************************
 Zrusi oznaceni kniham, kt. odpovidaji filtru}
procedure odznacitfiltr;
var
  lfind_autor,         {slouzi k vyplneni dotazniku, jen docasne}
  lfind_nazev,
  lfind_rok,
  lfind_druh,
  lfind_cislo :string;

  zrusit_akci :boolean; {zda neni vynuceno preruseni}

  odpovidaji_knihy :array [0..799] of word;  {!!!!! NUTNE DOLADIT}
                                           {seznam knih, kt. masce odpovidaji}
  pocet_odpovida :word;   {pocet knih ve vracenem seznamu}

  aw, bw :word;

begin
  if pocet_knih = 0 then exit;

  {predavame 'find' masky}
  lfind_autor := find_autor;
  lfind_nazev := find_nazev;
  lfind_rok   := find_rok;
  lfind_druh  := find_druh;
  lfind_cislo := find_cislo;

  {inicializace}
  zrusit_akci := false;
  parent_proces := 2;

  {vystavi formular na masky}
  formularfind (zrusit_akci,
                lfind_autor, lfind_nazev, lfind_druh, lfind_rok, lfind_cislo);

  {kdyz budeme pokracovat}
  if not zrusit_akci then begin
    {aktualizujeme 'find' masky}
    find_autor := lfind_autor;
    find_nazev := lfind_nazev;
    find_rok   := lfind_rok;
    find_druh  := lfind_druh [1];
    find_cislo := lfind_cislo;

    {testujeme masky}
    testujmasku (pocet_odpovida, odpovidaji_knihy,
                 find_autor, find_nazev, find_druh, find_rok, find_cislo);
    {vypis}
    {jdina (0, 10);
    pis ('pocet_odpovida: ');
    pisw (pocet_odpovida);}

    {nastavime oznaceni, takze vlastne odznacime}
    if pocet_odpovida > 0 then 
      for aw := 0 to (pocet_odpovida - 1) do begin
        bw := odpovidaji_knihy [aw]; {predvypocet}
        {kniha nebyla predtim oznacena}
        if oznacen^ [bw] = 1 then begin
    	  oznacen^ [bw] := 0;
    	  if pocet_oznacen > 0 then       {nemuzeme jit do zapornych cisel}
            pocet_oznacen := pocet_oznacen - 1;
        end;
      end;
  end;


  {repeat
    klavesa := getkey;
  until klavesa <> #0;}

  klavesa := #0;
end;



{****************************************
 ****************************************}
procedure menu;
var
  {one_radek :pointer;}
  hlavni_menu, kniha_menu, knihy_menu :pmenu_list;
begin
  {inicializace}
  hlavni_menu := nil;
  kniha_menu := nil;
  knihy_menu := nil;
  
  kniha_menu := submenu (hlavni_menu, 'Kniha');
    menuitem (kniha_menu, 'Pidat', 'F4', @pridatknihu);
    menuitem (kniha_menu, 'Editovat', 'Enter', @editovatknihu);
    menuitem (kniha_menu, 'Smazat', 'F8', @smazatknihu);
    menuitem (kniha_menu, 'Oznacit/odznacit', 'Ins', @oznacitknihu);
  knihy_menu := submenu (hlavni_menu, 'Knihy');
    menuitem (knihy_menu, 'Oznacit', '+', @oznacitfiltr);
    menuitem (knihy_menu, 'Odznacit', '-', @odznacitfiltr);
    menuitem (knihy_menu, 'Zmnit oznaen', '*', @inverzeoznaceni);
  menuitem (hlavni_menu, 'Uloit', 'F2', nil);
  menuitem (hlavni_menu, 'Tisk', 'F3', nil);
  menuitem (hlavni_menu, 'Nastaven', 'F9', nil);
  menuitem (hlavni_menu, 'Npovda', 'F1', nil);
  menuitem (hlavni_menu, 'Licence', '', nil);
  menuitem (hlavni_menu, '0 Programu', '', @o_programu);
  menuitem (hlavni_menu, 'Konec', 'Esc', @dotazkonec);

  runmenu (hlavni_menu, 0);
  freemenu (hlavni_menu);
  changewindow (root);
end;




{*********************************************************************
 *********************************************************************}
{
  HLAVNI PROGRAM
  }



{****************************************
 ****************************************}
begin
{INICIALIZACE}
{initcrt;
initkeyl;}
inittui;
initfile;
{inicializace klavesnice}
wait_on_key := true;
{setkeymap ('ces_lat2'); - predpoklada rezidentnni ovladac}
{inicializace barev}
setmenucolor (7, 3, 1, 1, 0, 7);
setinputlinecolor (7, 0, 0, 7);
setbuttoncolor (7, 1, 1, 7);


{Uvodni obrazovka pri nacitani}
{mazej;}
wbarva (7, 1);
wjdina (0, 0);
wpis ('verze                                    KNIHOVNA  Copyright (C) 2001 Petr Psa');
wjdina (6, 0);
wpis (verze);

wbarva (15, 0);
wjdina (0, 1);
wpis ('KNIHOVNA   - simple database utility for administration of register of books    ');
wjdina (0, 3);
wpis (' This program is free software; you can redistribute it and/or modify it under  ');
wpis (' the terms of the GNU General Public License as published by the Free Software  ');
wpis (' Foundation; either version 2, or (at your option) any later version.           ');
wjdina (0, 7);
wpis (' This program is distributed in the hope that it will be useful, but WITHOUT    ');
wpis (' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ');
wpis (' FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. ');
wpis (' (Also see the file "copying" or into this program or www.gnu.org, www.gnu.cz.) ');
wjdina (0, 12);
wpis (' You should have received a copy of the GNU General Public License along with   ');
wpis (' this program; if not, write to the Free Software Foundation, Inc.,             ');
wpis (' 675 Mass Ave, Cambridge, MA 02139, USA.                                        ');

{sem prijde indikacni pas}

wjdina (0, 20);
wpis (' Author''s address:                                                              ');
wpis ('  - paper mail: Petr Pisar            - e-mail   : petr.pisar@seznam.cz         ');
wpis ('                Uhercice 53           - web sites: http://www.fi.muni.cz/~xpisar');
wpis ('                53803 Hermanuv Mestec                                           ');
wpis ('                Czech Republic                                                  ');



{ALOKACE DYNAM. PROMENNYCH}
{str (MemAvail, filtr_autor);
str (MaxAvail, filtr_nazev);
jdina (0, 0);
pis (filtr_autor + ' bajtu k dispozici');
jdina (0, 1);
pis ('Nejvets volny blok ma ' + filtr_nazev  +  ' bajtu');

jdina (0, 2);
pis ('Potreba alokovat ');
pisw (maximalni_pocet_knih * 78);
pis (' B');}


getmem (autor, maximalni_pocet_knih * 32);
getmem (nazev, maximalni_pocet_knih * 32);
getmem (rok, maximalni_pocet_knih * 5);
getmem (cislo, maximalni_pocet_knih * 5);
getmem (druh, maximalni_pocet_knih * 1);
getmem (abc_total, maximalni_pocet_knih * 2);
getmem (oznacen, maximalni_pocet_knih * 1);

{str (MemAvail, filtr_autor);
str (MaxAvail, filtr_nazev);
jdina (0, 3);
pis (filtr_autor + ' bajtu k dispozici');
jdina (0, 4);
pis ('Nejvets volny blok ma ' + filtr_nazev +  ' bajtu');}

{repeat
until getkey <> #0;}

{nutne inicializace}
find_autor := '*';
find_nazev := '*';
find_rok := '*';
find_druh := '*';
find_cislo := '*';

{nuluji alokovanou pamet}
for aw := 0 to (maximalni_pocet_knih - 1) do begin
  autor^ [aw] := '';
  nazev^ [aw] := '';
  rok^ [aw] := '';
  druh^ [aw] := ' ';
  str (aw, cislo^ [aw]);
  abc_total^ [aw] := 65535;
  oznacen^ [aw] := 0;
end;

{ctu data z disku}
{cesta := paramstr (0);
jdina (0,1); pis (cesta);
repeat until getkey <> #0;}

{cesta := '..\..\pracovni\knihovna\'}; {melo byt prazdne cesta := ''; a
                                       spoustet program z adresare 'knihovna'
                                       prikazem '.\bin\knihovna.exe'}
{cesta := '/home/petr/programy/projekty/knihovna/';}


ctiknihovnu;


{repeat
until getkey <> #0;}
(*
{nasaveni zobrazovani casu}
auto_proc_on_getkey := @zobrazcas;
*)

{Testovaci hodnoty}


{pocet_knih := 20;
for aw := 0 to (pocet_knih - 1) do abc_total^ [aw] := aw + 1;

autor^ [0] := 'Capek Karel';   nazev^ [0] := 'Valka s mloky';    rok^ [0] := '2001'; druh ^[0] := 'S'; cislo^ [0] := '1';
autor^ [1] := 'Capek Karel';   nazev^ [1] := 'Hurdubal';         rok^ [1] := '2000'; druh^ [1] := 'K'; cislo^ [1] := '2';
autor^ [2] := 'Lem Stanislav'; nazev^ [2] := 'Hvezdne deniky 1'; rok^ [2] := '1998'; druh^ [2] := 'S'; cislo^ [2] := '3';
autor^ [3] := 'Capek Karel';   nazev^ [3] := 'Valka s mloky';    rok^ [3] := '2000'; druh^ [3] := 'S'; cislo^ [3] := '4';

abc_total^ [0] := 1;
abc_total^ [1] := 3;
abc_total^ [2] := 0;
abc_total^ [3] := 2;}


{definuji 'hlavni_klavesova_napoveda'}
{hlavni_klavesova_napoveda := ' <Esc> Konec <Enter> Editovat <F4> Pridat <F8> Smazat  <Ins> Oznacit <F10> Menu ';}

{pracovni obrazovka - horni a spodni radek}
wbarva (7, 0);
wmazej;
wbarva (7, 1);
wjdina (0, 0);
wpis ('                                   KNIHOVNA                                     ');
{zpodni radek - klavesova napoveda}
wjdina (0, 24);
wpis (' ');
wbarva (1, 3);
wpis ('Esc');
wbarva (7, 1);
wpis ('Konec ');
wbarva (1, 3);
wpis ('F2');
wbarva (7, 1);
wpis ('Uloit ');
wbarva (1, 3);
wpis ('Enter');
wbarva (7, 1);
wpis ('Editovat ');
wbarva (1, 3);
wpis ('F4');
wbarva (7, 1);
wpis ('Pidat ');
wbarva (1, 3);
wpis ('F8');
wbarva (7, 1);
wpis ('Smazat ');
wbarva (1, 3);
wpis ('Ins');
wbarva (7, 1);
wpis ('Oznait ');
wbarva (1, 3);
wpis ('F10');
wbarva (7, 1);
wpis ('Menu           ');
{ctiblok (0, 24, 79, 24, hlavni_klavesova_napoveda);}


{okno pro hodiny}
auto_proc_on_getkey := @zobrazcas;
swsize (nid, 8, 1);
swposition (nid, 72, 0);
swcolor (7, 1);
swhasborder (nid, false);
openwindow (hodiny);
changewindow (root);
swhasborder (nid, true);



{nadpisy  na zacatku seznamu}
wbarva (15, 0);
wjdina (0, 1);
wpis (' Autor                          Nzev                          Rok  Druh  slo ');


aktualni := 0;  {absolutni aktualni kniha}
virtualni := 0; {relativni aktualni kniha na obrazovce - na kolikatem radku
                 je zobrazena - 2}
horni := 0;     {ktera absolutni kniha je 1. na obrazovce}

konec_programu := false;
changewindow (root);
{seznam}
repeat
  {changewindow (root);}
  {zobrazi seznam}
  {vypocty dobre na zobrazeni}
  radek := 2;     {jen pomocny cislovac radku}
  dolni := horni + 21;
  if dolni > (pocet_knih - 1) then dolni := pocet_knih - 1;
  if pocet_knih <> 0 then begin
    {smazu hlasku upozorneni}
    if upozorneni <> 0 then begin
      closewindow (upozorneni);
      upozorneni := 0;
    end;
    {zobrazi max. 22 radku}
    wbarva (7, 0);

    
    {smaze vsechny radky}
    for aw := 0 to 21 do
      vypis[aw].text := '                                                                                ';
    a := 0;
    for aw := horni to dolni do begin {zobrazi 22 radku}
      bw := abc_total^ [aw];
      if oznacen^ [bw] = 0 then begin 
        vypis[a].fg := 7; {zvolime barvu podle oznacenosti}                     
        vypis[a].bg := 0;                                                       
      end                                                                       
      else begin                                                                
        vypis[a].fg := 2;                                                       
        vypis[a].bg := 0;                                                        
      end;                                                                      
      {vypise radek}                                                            
      vypis[a].text := autor^ [bw];                                             
      vypis[a].text[0] := char (31);                                            
      vypis[a].text := vypis[a].text + nazev^[bw];                              
      vypis[a].text[0] := char (62);                                               
      vypis[a].text := vypis[a].text + rok^[bw];                                
      vypis[a].text[0] := char (69);                                               
      vypis[a].text := vypis[a].text + druh^[bw];                                
      vypis[a].text[0] := char (80-length (cislo^[bw]));  
      vypis[a].text := vypis[a].text + cislo^[bw];                              
      vypis[a].text[0] := char (80);                                               
      inc (a);                                                                  
      radek := radek + 1;                                                       
    end;                                                                        
    {odlisi aktualni knihu, na ktere je prave kurzor}                           
    bw := abc_total^ [aktualni];                                                
    if oznacen^ [bw] = 0 then begin                                             
      vypis[virtualni].fg := 0; {zvolime barvu podle oznacenosti}               
      vypis[virtualni].bg := 7;                                                 
    end                                                                         
    else begin                                                                  
      vypis[virtualni].fg := 4;                                                 
      vypis[virtualni].bg := 7;                                                 
    end;                                                                        
    {a ted vse hezky vykreslime na obrazovku}                                   
    wjdina (0, 2);                                                                   for a := 0 to 21 do begin
      wjdina (0, a + 2);
      wbarva (vypis[a].fg, vypis[a].bg);  
      wpis (vypis[a].text);
     end;
  end

  {stane-li se, ze neni zadna kniha - seznam je prazdny, zobrazi hlasku}
  else begin
    if upozorneni = 0 then begin
      wbarva (7, 0);
      wjdina (0, 2);
      for a := 2 to 21 do
        wpis ('                                                                                ');
      upozorneni := prazdnaknihovna;
    end;
  end;
  
  {zobrazi informace}
  wbarva (7, 1);
  wjdina (0, 0);
  wpis ('          ');
  wjdina (0, 0);
  wpisw (pocet_knih);
  wpisz ('(');
  wpisw (pocet_oznacen);
  wpisz (')');

  {zobrazi akt. cas}
  {barva (7,1);
  jdina (72, 0);
  pis (cas);}


  {testuji klavesnici}
  repeat
    klavesa := getkey;
  until (klavesa <> #0) {and (key_type >= 3)};

  {Esc}
  if klavesa = #27 then dotazkonec; {Esc}


  {* -> inverze oznaceni}
  if (klavesa = '*') then inverzeoznaceni;

  {+ -> oznacit ty, kt. odpovidaji filtru}
  if (klavesa = '+') and (pocet_knih <> 0) then oznacitfiltr;

  {- -> odznacit ty, kt. odpovidaji filtru}
  if (klavesa = '-') and (pocet_knih <> 0) then odznacitfiltr;



if key_type >= 3 then begin


  {sipka nahoru}
  if (klavesa = #189) then jdioknihunahoru;

  {sipka dolu}
  if (klavesa = #191) then jdioknihudolu;

  {PgUp}
  if (klavesa = #185) and (pocet_knih > 0) then begin
    {seznam delsi nez 1 obrazovka}
    if (pocet_knih > 21) then begin
      {jsme na uplnem zacatku}
      if aktualni = 0 then begin
        aktualni := 0;
        virtualni := 0;
        horni := 0;
      end
      {nejse na zacatku}
      else begin
        {nelze jiz dal scrolovat -> jako pri Endu}
        if aktualni < (21) then begin
          aktualni := 0;
          virtualni := 0;
          horni := 0;
        end
        {jde dal scrolovat}
        else begin
          {vse je O.K. - klasicky scroling}
          if (aktualni > 41) then begin
            aktualni := aktualni - 20;
            horni := horni - 20;
          end
          {po odscrolovani by zacatek nebyl na prvnim radku}
          else begin
            aktualni := aktualni - 20;
            horni := 0;
            virtualni := aktualni - horni;
          end;
        end;
      end;
    end
    {seznam kratsi nez 1 obrazovka -> jako Home}
    else begin
      aktualni := 0;
      virtualni := 0;
      horni := 0;
    end;
  end;


  {PgDn}
  if (klavesa = #188) and (pocet_knih > 0) then begin

    {seznam delsi nez 1 obrazovka}
    if (pocet_knih > 21) then begin
      {jsme na uplnem zacatku}
      if aktualni = 0 then begin
        aktualni := 20;
        virtualni := 1;
        horni := 19;
      end
      {nejse na zacatku}
      else begin
        {nelze jiz dal scrolovat -> jako pri Endu}
        if aktualni > (pocet_knih - 21) then begin
          aktualni := pocet_knih - 1;
          virtualni := 20;
          horni := pocet_knih - 21;
        end
        {jde dal scrolovat}
        else begin
          {vse je O.K. - klasicky scroling}
          if (aktualni + 41) < pocet_knih then begin
            aktualni := aktualni + 20;
            horni := horni + 20;
          end
          {po odscrolovani by konec nebyl na predposlednim radku}
          else begin
            aktualni := aktualni + 20;
            horni := pocet_knih - 21;
            virtualni := aktualni - horni;
          end;
        end;
      end;
    end
    {seznam kratsi nez 1 obrazovka}
    else begin
      aktualni := pocet_knih - 1;
      virtualni := aktualni;
      horni := 0;
    end;
  end;

  {End}
  if (klavesa = #187) and (pocet_knih > 0) then begin
    aktualni := pocet_knih - 1;
    if pocet_knih > 21 then begin
      virtualni := 20;
      horni := pocet_knih - 21;
    end
    else begin
      virtualni := aktualni;
      horni := 0;
    end;
  end;

  {Home}
  if klavesa = #184 then begin
    aktualni := 0;
    virtualni := 0;
    horni := 0;
  end;

  {Ins -> knihu oznacime/odznacime}
  if (klavesa = #183) then oznacitknihu;

  {Sipka doleva -> skok na predchozi oznacenou knihu}
  if (klavesa = #190) then jdinaoznacenouknihunahoru;

  {Sipka doprava -> skok na dalsi oznacenou knihu}
  if (klavesa = #192) then jdinaoznacenouknihudolu;
(*
  {F1 -> Hlavni napoveda}
  if klavesa = #171 then napoveda ('hlavni');

  {F2 -> ulozi knihovnu na disk}
  if klavesa = #172 then ulozknihovnu;

  {F3 -> Tisk}
  if (klavesa = #173) and (pocet_knih <> 0) then print;
*)

  {F4 -> novou knihu chci vlozit}
  if (klavesa = #174) then pridatknihu;

  {Enter -> editace aktualni knihy}
  if (klavesa = #13) then editovatknihu;

  {F8 -> smazat knihu, v seznamu musi byt aspon 1 kniha}
  if (klavesa = #178) then smazatknihu;

  {F10 -> menu}
  if (klavesa = #180) then menu;

  end;
  changewindow (root);
until konec_programu;


if modifikovano then ulozknihovnu;

{ukonceni hodin}
auto_proc_on_getkey := nil;
closewindow (hodiny);
changewindow (root);

(*
{uvolneni dynam. promennych}
uvolniblok (hlavni_klavesova_napoveda);
*)

{UVOLNENI DATOVYCH DYNAMICKYCH PROMENNYCH}
freemem (autor, maximalni_pocet_knih * 32);
freemem (nazev, maximalni_pocet_knih * 32);
freemem (rok, maximalni_pocet_knih * 5);
freemem (cislo, maximalni_pocet_knih * 5);
freemem (druh, maximalni_pocet_knih * 1);
freemem (abc_total, maximalni_pocet_knih * 2);
freemem (oznacen, maximalni_pocet_knih * 1);



{UKONCOVANI}
wbarva (7, 0);
wmazej;

shutfile;
{hutkeyl;
shutcrt;}
shuttui;

write ('  KNIHOVNA ');
write (verze);
writeln ('    Copyright (C) 2001 Petr Pisar');
writeln ('    Licence GNU GPL 2 - text licence v .\doc\copying');
end.
